      PROGRAM hyperz_star_qso
c     Version: 26/11/2002
      IMPLICIT NONE
c
      INTEGER i,ii,iii,j,k,l,n_files,icomp,ncomp,kfil,iw_vega,iw,
     .     n_filter,iob,nob,id,iout_s,iout_m,law_rd,nfil,iroot,matrix,
     .     iw_ob,i_typ,i_red,i_lyf,nz,itype,iage,ntyp,i_as,ilyf,nlyf,
     .     izmin,itypem,iredm,ilyfm,npoiz,n_sol,iwav,npoiz1,npoiz2,
     .     last,nred,ired,law_nd,i_lyman,mxz,izsol,mxtyp_as,mxfil,mxred,
     .     mxlyf,mxwl_as,ndeg,magtyp,iunit_sed,i1,i2,icat,iblank,
     .     input,nparam,ipass,izmin1,iread,jread,nf,np,mxft,mxwf,
     .     nfilt_mabs,iz_clus,n_fil_wa,n_fil_w,itypea,ireda,ilyfa,
     .     iztyp,idum,izphot,i_sol,iout,iz,iforbid,n_head,npercent0,
     .     npercent,istep,nsteps
      REAL*8 w_vega,f_vega,f_as,z1,z2,amag,amag1,err_p,mag_nd,err_nd,
     .     err_min,avmin,avmax,averr,wl,surf,c_corr,val,p,err_fl,dz,
     .     zmax,zmin,zz,z,y,zop,z_min_array,filter,av,q_pro,dz_f,
     .     zmin_f,zmax_f,age,fl,qq,poids,poids_z,q_pro1,q_pro2,q_proz,
     .     chi2_b1,chi2_b2,z_b,z_b1,z_b2,dd,z_poids,qq_p,w0,wmin1,
     .     wmax1,wmin0,wmax0,wsyn,ysyn,d1,d2,yob,zz1,zz2,vega,flux,
     .     pthresh,conv_mag,bp1,time_tot,part_time,f_jy,err_jy,deg,
     .     pchi2,qchi2,zero,chi2,r_chi2,amabs_1,amabs_2,sauce,amagb,
     .     bmag,dif_w,dif_w_min,fl_temp,mag_temp,func,prob,err,x1,x2,
     .     ww,h0,om,ov,r,zeropoint,d_mod,color,z_clus,amagb_clus,
     .     p_clus,dummy,dummyz,zphot,chi2sol,qq2,fl_nd,fl1,ebv_mw,av_mw,
     .     rlin,fl_ext,chi2min,bb_array,c,fnu_vega,rnu_vega,wrnu,rrnu,
     .     f1,f2,ffnu,trapz1,fact_lyf,r_lyf,frac,wlmax,wlmin,
     .     f_as_max,rnorm_as
      REAL*8 fff,bm,wt,sxx,sxy,b,bb,bbb,ddummy
      REAL wv,fv,w_as,cputime,rmag,rerr_p
c
      PARAMETER (err=1.D-8,nparam=35)
      INCLUDE 'dimension_star.dec'
      INCLUDE 'filter.dec'

      LOGICAL header
      CHARACTER header_line*5000
      CHARACTER namech(mxtyp_as)*160,sed_abc(mxtyp_as)*2,line*240
      CHARACTER*160 spectra,amatrix,filedef,filein,filt_file,
     .     cat_in,spectra1,spectra2,spectra3,spectra4,spectra5,
     .     spec_vega,filtresfile,line_sed,filterout,copyright1,
     .     copyright2,copyright3
      CHARACTER clog*1,ccat*1,cz*1,csed1*1,csed2*1,cout_m*1,
     .     cout_s*1,root*8,date*24,vv*5
      CHARACTER fmt1*90,fmt2*90,fmt3*90,fmt4*90
      CHARACTER*40 cname,param(nparam)
c
      DIMENSION input(nparam),kfil(10)
      DIMENSION w_vega(4000),f_vega(4000),vega(0:mxfil)
      DIMENSION bp1(0:mxfil),conv_mag(0:mxfil)
      DIMENSION c_corr(mxfil),fl_nd(mxfil),fl1(mxfil)
      DIMENSION f_jy(mxfil),err_jy(mxfil),fl_temp(mxfil),mag_temp(mxfil)
      DIMENSION rmag(mxfil),rerr_p(mxfil)
      DIMENSION amag(mxfil),amag1(mxfil),err_p(mxfil)
      DIMENSION mag_nd(mxfil),err_nd(mxfil),law_nd(mxfil)
      DIMENSION ysyn(mxwl_as),wsyn(mxwl_as)
      DIMENSION ww(mxwl_as),yob(mxwl_as),y(mxwl_as)
      DIMENSION z_min_array(mxz)
      DIMENSION i_typ(mxz),i_red(mxz),i_lyf(mxz)
      DIMENSION wl(0:mxfil),flux(0:mxfil,0:mxz,mxtyp_as,mxred,mxlyf)
      DIMENSION q_pro(mxz),q_pro1(mxz),q_pro2(mxz),q_proz(mxz)
      DIMENSION z(0:mxz),z_b(mxz),z_b1(mxz),z_b2(mxz)
      DIMENSION chi2_b1(mxz),chi2_b2(mxz),iforbid(mxz),bb_array(mxz)
      DIMENSION izphot(mxz),zphot(mxz),bb(mxz),chi2sol(mxz)
      DIMENSION val(3),zz1(3),zz2(3),p(3)
      DIMENSION zeropoint(0:mxfil),n_fil_w(mxz)
      DIMENSION fnu_vega(4000),rnu_vega(4000)
      DIMENSION wrnu(mxwf),rrnu(mxwf),ffnu(mxwf)
      DIMENSION f_as_max(mxtyp_as),rnorm_as(mxtyp_as)
c
      EXTERNAL cputime,rlin,filter,pchi2,qchi2,zero,func,trapz1
      EXTERNAL d_mod,color
      COMMON/et1/surf(0:mxfil)
      COMMON/et2/fl(mxfil),err_fl(mxfil)
      COMMON/et2b/w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,mxtyp_as)
      COMMON/et3/law_rd
      COMMON/et4/n_filter,nfil(0:mxfil),iw(mxtyp_as),i_lyman(mxfil)
      COMMON/et5/bm
      COMMON/et6/ntyp(mxtyp_as)
      COMMON/compose/icomp
      COMMON/nfree/deg,prob
      COMMON/filterres/filtresfile
      COMMON/lyf_sigma/fact_lyf
c_________________________________________________________________________

      vv='1.2'
      copyright1=' hyperz_star photometric redshift code - Version '//vv
     .     //' (November 14, 2002)' 
      copyright2=' by Micol Bolzonella, Roser Pello'','
     .     //' Joan-Marc Miralles'
      copyright3=' More information at '
     .     //'http://webast.ast.obs-mip.fr/hyperz/'
      WRITE(*,*)
      WRITE(*,'(a80)') copyright1
      WRITE(*,*)
      WRITE(*,'(a80)') copyright2
      WRITE(*,'(a80)') copyright3
      WRITE(*,*)

      jread=0                   ! Control on reading A0VSED
      iread=0                   ! Control on reading Filter Library
      c=2.9979D+18              ! speed of light in AA/s
c ..... Probabilities for the confidence intervals
      p(1)=0.99D0
      p(2)=0.90D0
      p(3)=0.68D0
      x1=0.D0
      x2=200.D0
      ndeg=1
      deg=DBLE(REAL(ndeg))
      DO i=1,3
         prob=p(i)
         val(i)=zero(func,x1,x2,err)  ! chi2 for P = p(i) 
      END DO

c....... limits in absolute magnitude

      amabs_1=-100.0D0
      amabs_2=100.0D0
      z_clus=-1.D0

 11   filein='hyperz_star_qso.param'
      last=INDEX(filein,'  ')-1
      WRITE(*,*) 'Name of parameter file'
      WRITE(*,*) '[default = ',filein(1:last),']'
      READ(*,'(A)') line
      IF (line.ne.' ') THEN
         READ(line,'(A)',ERR=11) filein
      END IF
      time_tot=DBLE(cputime())
c ------------------------------------------------------------------------
c                       Reading parameters file 
c ------------------------------------------------------------------------

c ..... Parameters in common hyperz & make_catalog
      param(1)='A0VSED'
      param(2)='FILTERS_RES'
      param(3)='FILTERS_FILE'
      param(4)='TEMPLATES_FILE'
      param(5)='MAG_TYPE'
      param(6)='ERR_MAG_MIN'
      param(7)='Z_MIN'
      param(8)='Z_MAX'
      param(9)='REDDENING_LAW'
      param(10)='AV_MIN'
      param(11)='AV_MAX'
      param(12)='LY_FOREST'
      param(13)='OUTPUT_FILE'
      param(14)='H0'
      param(15)='OMEGA_M'
      param(16)='OMEGA_V'
c ..... Parameters relative to hyperz only
      param(17)='FILT_M_ABS'
      param(18)='CATALOG_FILE'
      param(19)='CATALOG_TYPE'
      param(20)='Z_STEP'
      param(21)='ZSTEP_TYPE'
      param(22)='AV_STEP'
      param(23)='PROB_THRESH'
      param(24)='OUTPUT_TYPE'
      param(25)='SED_OBS_FILE'
      param(26)='SED_TEMP_FILE'
      param(27)='LOGPHOT_FILE'
      param(28)='CATPHOT_FILE'
      param(29)='ZPHOT_FILE'
c ..... Optional parameters
      param(30)='Z_CLUSTER'
      param(31)='M_ABS_MIN'
      param(32)='M_ABS_MAX'
      param(33)='MATRIX'
      param(34)='SPECTRUM'
      param(35)='EBV_MW'

      DO i=1,nparam
         input(i)=0
      END DO
      ebv_mw=0.D0

      OPEN(77,FILE=filein,STATUS='old',ERR=11)
      WRITE(*,*) 'Reading parameter file :'

 7    READ(77,'(A)',ERR=10,END=10) line
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            GO TO 8
         END IF
      END DO
      GO TO 7  ! blank line
 8    IF (line(1:1).eq.'#') GO TO 7 ! comment line
      iblank=INDEX(line,' ')
      cname=line(1:iblank-1) ! variable name
      line=line(iblank:)
      DO i=1,80
         IF (line(i:i).ne.' ') THEN
            line=line(i:)
            IF (line(1:1).eq.'#') THEN
               WRITE(*,*) 'Missed value of variable ', cname
               STOP
            END IF
            GO TO 9
         END IF
      END DO
      WRITE(*,*) 'Missed value of variable ', cname
      STOP
 9    iblank=INDEX(line,' ')
      line=line(1:iblank-1) ! part of string containing value of variable
c Parameters in common hyperz & make_catalog
c ..... File containing Vega spectrum
      IF (cname.eq.param(1)) THEN
         READ(line,'(A)') spec_vega
         input(1)=1
         GO TO 7
c ..... File FILTER.RES
      ELSE IF (cname.eq.param(2)) THEN
         READ(line,'(A)') filtresfile
         input(2)=1
         GO TO 7
c ..... File containing filter parameters and instructions for 
c       non detected objects (nd) or out of file (oof) for each filter
c       0 -> flux = -1 (filter not considered) for either nd or oof
c       1 -> flux = -1 for oof, flux = 0, err_flux = flux_nd for nd
c       2 -> flux = -1 for oof, flux = flux_nd/2, err_flux = flux_nd/2 for nd
c       3 -> flux = -1 for oof, mag = mag_nd,  err = err_nd for nd
      ELSE IF (cname.eq.param(3)) THEN
         READ(line,'(A)') filt_file
         input(3)=1
         GO TO 7
c ..... File containing synthetic spectra filenames
      ELSE IF (cname.eq.param(4)) THEN
         READ(line,'(A)') filedef
         input(4)=1
         GO TO 7
c ..... Magnitude type:
c       0 -> standard magnitudes
c       1 -> AB magnitudes
c       2 -> Flux in microJansky
      ELSE IF (cname.eq.param(5)) THEN
         READ(line,*) magtyp
         IF (magtyp.ne.0.and.magtyp.ne.1.and.magtyp.ne.2) THEN
            WRITE(*,*) 'MAG_TYPE must be 0 , 1 or 2'
            STOP
         END IF
         input(5)=1
         GO TO 7
c ..... Minimum error in magnitude (if error < err_min => err = err_min)
      ELSE IF (cname.eq.param(6)) THEN
         READ(line,*) err_min
         input(6)=1
         GO TO 7
c ..... Redshift range (utilized only if icat=0) and step for scan
      ELSE IF (cname.eq.param(7)) THEN
         READ(line,*) zmin
         input(7)=1
         GO TO 7
      ELSE IF (cname.eq.param(8)) THEN
         READ(line,*) zmax
         input(8)=1
         GO TO 7
c ..... Reddening:
c       0 -> No reddening
c       1 -> Allen, 1976, standard MW
c       2 -> Seaton, 1979, standard MW
c       3 -> Fitzpatrick, 1986, LMC
c       4 -> Prevot, 1984 + Bouchet, 1985, SMC
c       5 -> Calzetti et al., 2000
      ELSE IF (cname.eq.param(9)) THEN
         READ(line,*) law_rd
         IF (law_rd.ne.0.and.law_rd.ne.1.and.law_rd.ne.2.and.
     .        law_rd.ne.3.and.law_rd.ne.4.and.law_rd.ne.5) THEN
            WRITE(*,*) 'REDDENING_LAW must be 0 -- 5'
            STOP
         END IF
         input(9)=1
         GO TO 7
c ..... Av_max, Av_min
      ELSE IF (cname.eq.param(10)) THEN
         READ(line,*) avmin
         input(10)=1
         GO TO 7
      ELSE IF (cname.eq.param(11)) THEN
         READ(line,*) avmax
         input(11)=1
         GO TO 7
c .... Lyman Forest
      ELSE IF (cname.eq.param(12)) THEN
         READ(line,*) r_lyf
         IF (r_lyf.lt.1.D-4) r_lyf=1.D0
         IF (r_lyf.lt.1.D0) r_lyf=1.D0/r_lyf
         IF (ABS(r_lyf-1.D0).lt.1.D-4) THEN
            nlyf=1 ! considering only the mean Madau value
         ELSE
            nlyf=3 ! considering 3 values: mean Madau value + 2 values 
         END IF
         input(12)=1
         GO TO 7
c ..... Output files: no extension (file = *)
c       *.cat_phot -> catalogue
c       *.log_phot -> log file
c       *.sed      -> SED
c       *.z_phot   -> catalogue with only first maximum
      ELSE IF (cname.eq.param(13)) THEN
         READ(line,'(A)') spectra
         iblank=INDEX(spectra,' ')
         spectra1=spectra(1:iblank-1)//'.cat_phot'
         spectra2=spectra(1:iblank-1)//'.log_phot'
         spectra3=spectra(1:iblank-1)//'.obs_sed'
         spectra4=spectra(1:iblank-1)//'.z_phot'
         spectra5=spectra(1:iblank-1)//'.temp_sed'
         filterout=spectra(1:iblank-1)//'.out_phot'
         input(13)=1
         GO TO 7
c ..... Cosmological parameters to compute the universe age and M_abs 
      ELSE IF (cname.eq.param(14)) THEN
         READ(line,*) h0
         input(14)=1
         GO TO 7
      ELSE IF (cname.eq.param(15)) THEN
         READ(line,*) om
         input(15)=1
         GO TO 7
      ELSE IF (cname.eq.param(16)) THEN
         READ(line,*) ov
         input(16)=1
         GO TO 7
c Parameters relative to hyperz only
c ..... Filter for the absolute magnitude
      ELSE IF (cname.eq.param(17)) THEN
         READ(line,*) nfilt_mabs
         input(17)=1
         GO TO 7
c ..... File containing photometric catalogue
      ELSE IF (cname.eq.param(18)) THEN
         READ(line,'(A)') cat_in
         input(18)=1
         GO TO 7
c ..... Catalogue format 
c       Format of objects catalogue: 
c       N,[z_min,z_max,](mag(i),i=1,n),(err(i),i=1,n)
      ELSE IF (cname.eq.param(19)) THEN
         READ(line,*) icat
         IF (icat.ne.0.and.icat.ne.1) THEN
            WRITE(*,*) 'CATALOG_TYPE must be 0 or 1'
            STOP
         END IF
         input(19)=1
         GO TO 7
c ..... Redshift step used to build hypercube
      ELSE IF (cname.eq.param(20)) THEN
         READ(line,*) dz
         input(20)=1
         GO TO 7
c ..... Type of redshift step: 
c       0 -> step = Z_STEP; 1 -> step = Z_STEP*(1+z)
      ELSE IF (cname.eq.param(21)) THEN
         READ(line,*) iztyp
         IF (iztyp.ne.0.and.iztyp.ne.1) THEN
            WRITE(*,*) 'ZSTEP_TYPE must be 0 or 1'
            STOP
         END IF
         input(21)=1
         GO TO 7
c ..... Reddening step used to build hypercube
      ELSE IF (cname.eq.param(22)) THEN
         READ(line,*) averr
         input(22)=1
         GO TO 7
c ..... Probability threshold for the study of secondary maxima
      ELSE IF (cname.eq.param(23)) THEN
         READ(line,*) pthresh
         input(23)=1
         GO TO 7
c ..... Output SED: 
c       0 -> erg/s/cm^2/A ; 1 -> microJansky ; 2 -> AB magnitudes
      ELSE IF (cname.eq.param(24)) THEN
         READ(line,*) iunit_sed
         IF (iunit_sed.ne.0.and.iunit_sed.ne.1.and.iunit_sed.ne.2) THEN
            WRITE(*,*) 'OUTPUT_TYPE must be 0, 1 or 2'
            STOP
         END IF
         input(24)=1
         GO TO 7
c ..... File .obs_sed (y/n)
      ELSE IF (cname.eq.param(25)) THEN
         csed1=line(1:1)
         input(25)=1
         GO TO 7
c ..... File .temp_sed (y/n)
      ELSE IF (cname.eq.param(26)) THEN
         csed2=line(1:1)
         input(26)=1
         GO TO 7
c ..... File .log_phot (y/n)
      ELSE IF (cname.eq.param(27)) THEN
         clog=line(1:1)
         input(27)=1
         GO TO 7
c ..... File .cat_phot (y/n)
      ELSE IF (cname.eq.param(28)) THEN
         ccat=line(1:1)
         input(28)=1
         GO TO 7
c ..... File .z_phot (y/n)
      ELSE IF (cname.eq.param(29)) THEN
         cz=line(1:1)
         input(29)=1
         GO TO 7
c Optional parameters
c ..... Cluster redshift (optional)
      ELSE IF (cname.eq.param(30)) THEN
         READ(line,*) z_clus
         input(30)=1
         GO TO 7
c ..... Limits for absolute magnitude (optional)
      ELSE IF (cname.eq.param(31)) THEN
         READ(line,*) amabs_1
         input(31)=1
         GO TO 7
      ELSE IF (cname.eq.param(32)) THEN
         READ(line,*) amabs_2
         input(32)=1
         GO TO 7
c ..... Matrix/obj (optional)
      ELSE IF (cname.eq.param(33)) THEN
         cout_m=line(1:1)
         input(33)=1
         GO TO 7
c ..... Spectrum/obj (optional)
      ELSE IF (cname.eq.param(34)) THEN
         cout_s=line(1:1)
         input(34)=1
         GO TO 7
c .... galactic dereddening (optional)
      ELSE IF (cname.eq.param(35)) THEN
         READ(line,*) ebv_mw
         input(35)=1
         GO TO 7
      ELSE 
c         WRITE(*,'(a,1x,a)') 'Unknown parameter (ignored)',cname
         GO TO 7
      END IF

 10   CONTINUE
      CLOSE(77)
      DO i=1,nparam-6           ! Last 6 parameters are optional
         IF (input(i).eq.0.and.i.ne.12) THEN
            WRITE(*,*) 'Missed parameter ', param(i)
            STOP
         END IF
      END DO
      IF (input(12).eq.0) THEN ! Consistency with the previous version
         r_lyf=1.D0
         nlyf=1
      END IF

c ..... Control of optional parameters      
      IF (input(nparam-5).eq.1.and.icat.eq.0) THEN
         IF (z_clus.lt.zmin.or.z_clus.gt.zmax) THEN
            WRITE(*,*) 'Z_CLUSTER must be in the interval [Z_MIN,Z_MAX]'
            STOP
         END IF
      END IF
      iout_m=1
      iout_s=1
      IF (input(nparam-2).eq.1.and.
     .     cout_m.eq.'y'.or.cout_m.eq.'Y') iout_m=2
      IF (input(nparam-1).eq.1.and.
     .     cout_s.eq.'y'.or.cout_s.eq.'Y') iout_s=2

      av_mw=3.1D0*ebv_mw

      IF (law_rd.eq.0) THEN
         avmin=0.0D0
         avmax=0.0D0
         averr=1.0D0
      END IF
      nred=INT(ABS(avmax-avmin)/averr)+1
      IF (nred.gt.mxred) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of reddening steps exceeding the maximum [max=',
     .        mxred,']'
         STOP
      END IF

      OPEN(10,FILE=filedef,STATUS='old',ERR=78)
      iii=1
 2230 READ(10,'(A)',ERR=2220,END=2220) line_sed
      IF (line_sed(1:1).eq.'#'.or.line_sed.eq.' ') GO TO 2230
      last=INDEX(line_sed,' ')-1
      namech(iii)=line_sed(1:last)
      line_sed=line_sed(last+1:)
      DO i=1,80
         IF (line_sed(i:i).ne.' ') THEN
            line_sed=line_sed(i:)
            GO TO 2221
         END IF
      END DO
      WRITE(*,*) 'Missed type of SED file ', namech(iii)
      STOP
 2221 sed_abc(iii)=line_sed(1:2)
      IF ((sed_abc(iii).eq.'AS').or.(sed_abc(iii).eq.'A ')) THEN
         iii=iii+1
         GO TO 2230
      ELSE
         last=INDEX(namech(iii),' ')-1
         WRITE(*,'(1x,a)') 'SED '//namech(iii)(1:last)//' is of type '
     .        //sed_abc(iii)
         WRITE(*,'(1x,a)') 'SED type must be AS'
         STOP
      END IF
 2220 n_files=iii-1
      IF (n_files.gt.mxtyp_as) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of files exceeding the maximum [max=',mxtyp_as,']'
         STOP
      END IF
      WRITE(*,*) 'There are ',n_files,' synthetic spectra'
      CLOSE(10)

      CALL filter0
      OPEN(10,FILE=filt_file,STATUS='old',ERR=80)
      i=0
 134  CONTINUE
      READ(10,'(A)',ERR=135,END=135) line
      IF (line(1:1).eq.'#'.or.line.eq.' ') GO TO 134
      i=i+1
      ncomp=1
      DO k=1,80
         IF (line(k:k).eq.'&') THEN
            line(k:k)=' '
            ncomp=ncomp+1
         ELSE IF (line(k:k).eq.'#') THEN
            GO TO 136
         END IF
      END DO
 136  CONTINUE
      IF (ncomp.eq.1) THEN 
         READ(line,*,ERR=82) nfil(i),c_corr(i),law_nd(i),
     .        mag_nd(i),err_nd(i)
         IF (law_nd(i).ne.0.and.law_nd(i).ne.1.and.law_nd(i).ne.2.and.
     .        law_nd(i).ne.3) THEN
            WRITE(*,*) 'Non detection law must be 0, 1, 2 or 3'
            WRITE(*,*) 'Check filter ', nfil(i)
            STOP
         END IF
         IF (nfil(i).gt.icomp) THEN
            WRITE(*,1998) nfil(i),icomp
            STOP
         ELSE
c ..... simple filter
            kfil(1)=nfil(i)
            CALL compos_new(1,kfil,wl(i),surf(i),bp1(i))
            GO TO 134
         END IF
      ELSE 
         READ(line,*,ERR=82) (kfil(j),j=1,ncomp),c_corr(i),law_nd(i),
     .                 mag_nd(i),err_nd(i)
         IF (law_nd(i).ne.0.and.law_nd(i).ne.1.and.law_nd(i).ne.2.and.
     .        law_nd(i).ne.3) THEN
            WRITE(*,*) 'Non detection law must be 0, 1, 2 or 3'
            WRITE(*,*) 'Check filter ', nfil(i)
            STOP
         END IF
c ..... composite filter
         icomp=icomp+1
         nfil(i)=icomp
         CALL compos_new(ncomp,kfil,wl(i),surf(i),bp1(i))
         GO TO 134
      END IF
 1998 FORMAT('Filter number ',I4, ' out of range!',/,
     .       'Maximum = ',I4)

 135  n_filter=i
      IF (n_filter.gt.mxfil) THEN
         WRITE(*,'(1x,a,i3,a)') 
     .        'Number of filters exceeding the maximum [max=',mxfil,']'
         STOP
      END IF
      WRITE(*,*) 'There are ',n_filter,' filters'
      nfil(0)=nfilt_mabs ! filter for absolute magnitude estimates
      kfil(1)=nfil(0)
      CALL compos_new(1,kfil,wl(0),surf(0),bp1(0))
      CLOSE(10)

      OPEN(10,FILE=cat_in,STATUS='old',ERR=79)

c ..... Reading the header (thanks to V. Le Brun)
      header = .FALSE.
      READ(10,'(A)',ERR=79) header_line
      IF (header_line(1:1).eq.'#'.or.header_line.eq.' ') THEN
         header= .TRUE.
         i=1
 44      READ(10,'(A)',ERR=79) header_line
         IF (header_line(1:1).eq.'#'.or.header_line.eq.' ') THEN
            i=i+1
            GO TO 44
         ELSE
            n_head=i
         END IF
      END IF
      CLOSE(10)
      OPEN(10,FILE=cat_in,STATUS='old',ERR=79)
c ..... Skipping the header (thanks to V. Le Brun)
      IF (header) THEN
         DO i=1,n_head
            READ(10,'(A)') header_line
         END DO
      END IF

      IF (icat.eq.0) THEN
         iob=0
 1340    CONTINUE
         iob=iob+1
         READ(10,*,ERR=1350,END=1350) id,(rmag(i),i=1,n_filter),
     .        (rerr_p(i),i=1,n_filter)
         z1=zmin
         z2=zmax
         GO TO 1340
      ELSE IF (icat.eq.1) THEN
         iob=0
 1341    CONTINUE
         iob=iob+1
         READ(10,*,ERR=1350,END=1350) id,z1,z2,(rmag(i),i=1,n_filter),
     .        (rerr_p(i),i=1,n_filter)
         IF(z1.lt.zmin) zmin=z1
         IF(z2.gt.zmax) zmax=z2
         GO TO 1341
      ELSE
         GO TO 79
      END IF
 1350 nob=iob-1
      WRITE(*,*) 'There are ',nob,' objects in the catalogue'
      CLOSE(10)

      IF (iout_m.gt.1.and.nob.gt.100) THEN
         iout=0
         WRITE(*,'(a,i6,a)') ' You chose output matrix for all ',
     .        nob, ' objects' 
         WRITE(*,'(a)') ' Are you sure?'
         WRITE(*,*) 'Type 0 to continue with matrix, 1 without matrix'
         WRITE(*,*) '[<return>=1]'
         READ(*,'(a)') line 
         IF (line.ne.' ') THEN
            READ(line,*) iout
            IF (iout.eq.0) iout_m=2
         END IF
      END IF
      z(0)=0.D0
      z(1)=zmin
      i=1
 88   i=i+1
      IF (iztyp.eq.0) THEN
         z(i)=z(i-1)+dz
      ELSE IF (iztyp.eq.1) THEN
         z(i)=z(i-1)+(1.D0+z(i-1))*dz
      END IF
      IF (zmax-z(i).gt.1.D-3) GO TO 88
      nz=i
      IF (nz.gt.mxz) THEN
         WRITE(*,'(1x,a,i4,a)') 
     .        'Number of redshift steps exceeding the maximum [max=',
     .        mxz,']'
         WRITE(*,*) 'Choose a larger Z_STEP or a smaller Z_MAX'
         STOP
      END IF

c -----------------------------------------------------------------------
c                       Reading synthetic spectra 
c -----------------------------------------------------------------------

c ..... Vega

      WRITE (*,'(1x,a)') 'Reading reference sed:'
      OPEN(10,FILE=spec_vega,STATUS='old')
      READ(10,'(A)') line
      WRITE(*,'(1x,a)') line (1:78)
      iii=1
 223  READ(10,*,ERR=222,END=222) wv,fv
      w_vega(iii)=DBLE(wv)
      f_vega(iii)=DBLE(fv)
      iii=iii+1
      GO TO 223
 222  iw_vega=iii-1
      CLOSE(10)
      WRITE(*,*) 'There are ',iw_vega,' points in Vega'
      jread=iw_vega

c maximum and minimum wavelength in filters
      wlmax=0.D0
      wlmin=1.D8
      DO i=1,n_filter
         wlmax=MAX(wlmax,r(np(i),i,1))
         wlmin=MIN(wlmin,r(1,i,1))
      END DO
c maximum wavelength at the maximum redshift
      wlmax=wlmax*(1.D0+zmax)
c minimum wavelength at the minimum redshift
      wlmin=wlmin*(1.D0+zmin)

c ..... SED

      WRITE(*,*) 'Reading synthetic spectra :'
      i_as=0
      DO i=1,n_files
         WRITE(*,2005) i,namech(i)
c ASCII templates only
         OPEN(1,FILE=namech(i),STATUS='old',FORM='formatted',ERR=25)
         i_as=i_as+1
         f_as_max(i_as)=-100.D0
         IF (i_as.gt.mxtyp_as) THEN
            WRITE(*,'(a,i3)') 
     .           ' Number of ASCII templates exceeding the maximum.' 
     .           //' Max = ',mxtyp_as
            WRITE(*,'(a)') 
     .           ' Reduce ASCII SEDs or modify mxtyp_as in '
     .           //'dimension_star.dec and recompile'
            STOP
         END IF
         ntyp(i)=i_as
         ii=1
 33      READ(1,*,ERR=34,END=34) w_as(ii,i_as),fff
c     f_as(ii,i_as)=DBLE(fff)
         f_as(ii,i_as)=fff
         IF (f_as(ii,i_as).gt.f_as_max(i_as)) THEN	
            f_as_max(i_as)=f_as(ii,i_as)
         END IF
         ii=ii+1
         IF (ii.gt.mxwl_as) THEN
            WRITE(*,'(a,i6)') 'Number of wavelengths in ASCII '
     .           //'templates exceeding the maximum. Max = ',mxwl_as
            WRITE(*,'(a)') 
     .           ' Reduce ASCII wavelenghts or modify mxwl_as in '
     .           //'dimension.dec and recompile'
            STOP
         END IF
         GO TO 33
 34      iw(i)=ii-1
         CLOSE(1)
         IF (w_as(iw(i),i_as).lt.wlmax) THEN
            WRITE(*,'(a,i3,a)') ' Template ',i,' does not '
     .           //'encompass the reddest wavelength of filters '
            WRITE(*,'(a,f10.2)') ' at zmax. lambda_max(zmax) =',wlmax 
            WRITE(*,'(a)') ' Decrease zmax or change the template'
            STOP
         END IF
         IF (w_as(1,i_as).gt.wlmin) THEN
            WRITE(*,'(a,i3,a)') ' Template ',i,' does not '
     .           //'encompass the bluest wavelength of filters '
            WRITE(*,'(a,f10.2)') ' at zmin. lambda_min(zmin) =',wlmin 
            WRITE(*,'(a)') ' Increase zmin or change the template'
            STOP
         END IF
         
         rnorm_as(i_as)=1.D0
         IF (f_as_max(i_as).ge.1.D0.and.f_as_max(i_as).le.10.D0) THEN
            DO ii=1,iw(i)
               IF (w_as(ii,i_as).lt.912.) f_as(ii,i_as)=0.D0
            END DO
            
         ELSE
            IF (f_as_max(i_as).gt.10.D0) THEN
 54            rnorm_as(i_as)=rnorm_as(i_as)*10.D0
               f_as_max(i_as)=f_as_max(i_as)/10.D0
               IF (f_as_max(i_as).le.10.D0) THEN
                  DO ii=1,iw(i)
                     f_as(ii,i_as)=f_as(ii,i_as)/rnorm_as(i_as)
                     IF (w_as(ii,i_as).lt.912.) f_as(ii,i_as)=0.D0
                  END DO
               ELSE
                  GO TO 54
               END IF
            ELSE IF (f_as_max(i_as).lt.1.D0) THEN
 56            rnorm_as(i_as)=rnorm_as(i_as)/10.D0
               f_as_max(i_as)=f_as_max(i_as)*10.D0
               IF (f_as_max(i_as).ge.1.D0) THEN
                  DO ii=1,iw(i)
                     f_as(ii,i_as)=f_as(ii,i_as)/rnorm_as(i_as)
                     IF (w_as(ii,i_as).lt.912.) f_as(ii,i_as)=0.D0
                  END DO
               ELSE
                  GO TO 56
               END IF
            END IF
         END IF
         
 36      CLOSE(1)
      END DO
 2005 FORMAT(' Type ', I3, ' : ', A67)
c -----------------------------------------------------------------------
c                    Filters and .out_phot file
c -----------------------------------------------------------------------

      OPEN(18,FILE=filterout,STATUS='unknown')
      WRITE(18,'(a)')
     .     '##########################################################'
      WRITE(18,'(a,1x,a)')
     .     '# This is the output file of hyperz - Version '//vv
      WRITE(18,'(a)')
     .     '##########################################################'
      CALL fdate(date)
c      CALL fdate_(date)   ! IBM
      WRITE(18,'(a)') '# Date: '//date
      WRITE(18,'(a)') '# Photometric catalogue : '
      last=INDEX(cat_in,' ')-1
      WRITE(18,'(2x,a)')  cat_in(1:last)
      WRITE(18,'(a)') 
     .     '# Templates SEDs:'
      DO itype=1,n_files
         last=INDEX(namech(itype),' ')-1
         WRITE(18,'(2x,i2,2x,a,2x,a)') itype,namech(itype)(1:last),
     .     sed_abc(itype)
      END DO
      WRITE(18,'(a)') '# Characteristics of filters'
      WRITE(18,'(a)') 
     .     '#  n     wl_eff     surface   bandpass1  conv_AB mlim(Vega)'
     .     //' nd'
      zz=0.D0

c ..... Conversion from AB to standard magnitudes: conv_mag = AB - Vega
c compute f_Vega(nu)
      DO i=1,iw_vega
c         fnu_vega(i)=f_vega(i)*2.E-17*w_vega(i)*w_vega(i)/c
         fnu_vega(i)=f_vega(i)*2.D0*w_vega(i)*w_vega(i)/2.9979D0
         rnu_vega(i)=c/w_vega(i)
      END DO
      DO k=0,n_filter
         vega(k)=filter(nfil(k),w_vega,f_vega,iw_vega,zz) ! unit 2.E-17
         zeropoint(k)=-color(nfil(k),nfilt_mabs,
     .                       w_vega,f_vega,iw_vega,zz)
c         f_nu=(vega(k)*2.E-17/surf(k))*wl(k)**2/(2.9979E+18)
c         f_nu=(vega(k)*2./surf(k))*wl(k)**2/2.9979
c         conv_mag(k)=-2.5*(-35.+LOG10(f_nu))-48.60 ! approx value

c transmission function R(nu): R(nu) d(nu)= R(lambda) d(lambda)
         DO i=1,np(nfil(k))
            wrnu(i)=c/r(i,nfil(k),1) ! frequency
            rrnu(i)=r(i,nfil(k),2)*c/(wrnu(i)*wrnu(i)) ! R(nu)
         END DO
c R(nu)*f_vega(nu)
         DO i=1,np(nfil(k))
            l=0
            ffnu(i)=rrnu(i)*rlin(wrnu(i),rnu_vega,fnu_vega,iw_vega,l)
         END DO
c integrals with trapezoids
         f1=trapz1(wrnu,ffnu,np(nfil(k)))
         f2=trapz1(wrnu,rrnu,np(nfil(k)))
         conv_mag(k)=-2.5D0*(-35.D0+DLOG10(f1/f2))-48.60D0
c ..... Wavelength limit for the break in each filter 
c         aw_limit(k)=r(np(nfil(k))-1,nfil(k),1)
      END DO
      DO k=1,n_filter
c ..... Flux corresponding to the limiting magnitude (N.B. unit 2.E-17)
         IF (magtyp.eq.0) THEN
            fl_nd(k)=vega(k)*
     .           10**(-0.4D0*(mag_nd(k)+c_corr(k)))/surf(k) 
            mag_nd(k)=-2.5D0*DLOG10(fl_nd(k)*surf(k)/vega(k)) !Vega limiting mag
         ELSE IF (magtyp.eq.1) THEN
            fl_nd(k)=(10**(-0.4D0*(mag_nd(k)+c_corr(k)+48.6D0))*
     .           (2.9979D+18/(wl(k)**2)))/2.D-17  
            mag_nd(k)=-2.5D0*DLOG10(fl_nd(k)*surf(k)/vega(k)) !Vega limiting mag
         ELSE IF (magtyp.eq.2) THEN ! muJy -> 2.E-17 erg/s/cm2/Hz
            fl_nd(k)=mag_nd(k)*1.D-12*0.5D0*(2.9979D+18/(wl(k)**2)) 
            mag_nd(k)=-2.5D0*DLOG10(fl_nd(k)*surf(k)/vega(k)) !Vega limiting mag
         END IF
         WRITE(18,1999) nfil(k),wl(k),surf(k),bp1(k),conv_mag(k),
     .        mag_nd(k),law_nd(k)

      END DO
 1999 FORMAT(2X,I3,1X,F11.3,1X,2(F10.3,1X),1X,F7.3,1X,F7.3,4X,I2)
      WRITE(18,'(a)') '#    zmin      zmax     zstep'
      WRITE(18,'(4X,3(F5.2,5X))') zmin,zmax,dz
      WRITE(18,'(a)') '#    AVmin     AVmax    AVstep  red_law'
      WRITE(18,'(4X,3(F5.2,5X),I2)') avmin,avmax,averr,law_rd
      WRITE(18,'(a)') 
     .     '#    Lyman_forest [factor(s) multiplying <tau_eff>]'
      IF (nlyf.eq.1) WRITE(18,'(4X,F6.3)') r_lyf
      IF (nlyf.eq.3) WRITE(18,'(4X,3(F6.3,2X))') 
     .     1.D0/r_lyf,r_lyf/r_lyf,r_lyf
c      WRITE(18,'(a)') '#    Mmin      Mmax     Mfilter  mag type'
      WRITE(18,'(a)') 
     .     '#    Mmin(Vega) Mmax(Vega) Mfilter input mag type'
      IF (magtyp.eq.0) WRITE(18,'(4X,2(F7.2,3X),6X,I3,6X,A)') 
     .     amabs_1,amabs_2,nfilt_mabs,'Vega'
      IF (magtyp.eq.1) WRITE(18,'(4X,2(F7.2,3X),6X,I3,6X,A)') 
     .     amabs_1,amabs_2,nfilt_mabs,'AB'
      IF (magtyp.eq.2) WRITE(18,'(4X,2(F7.2,3X),6X,I3,6X,A)') 
     .     amabs_1,amabs_2,nfilt_mabs,'muJy'
      WRITE(18,'(a)') '#    Omega_0   Omega_v  H_0'
      WRITE(18,'(4X,3(F5.2,5X))') om,ov,h0
c -----------------------------------------------------------------------
c                          Building Hypercube! 
c -----------------------------------------------------------------------
      WRITE(*,'(1x,a)') 'Building hypercube ...'
      part_time=DBLE(cputime())
c     compute the number of steps to report the completed percentage
      nsteps=0
      DO ired=1,nred
         DO i=0,nz
            DO itype=1,n_files
               DO ilyf=1,nlyf
                  nsteps=nsteps+1
               END DO
            END DO
         END DO
      END DO

      istep=0
      npercent0=0
      WRITE(*,'(a,i4,a)') ' Hypercube: ',25*npercent0,'% done'
      DO ired=1,nred
         av=avmin+(ired-1)*averr
         DO i=0,nz
            DO itype=1,n_files
               DO k=1,iw(itype)
                  y(k)=f_as(k,ntyp(itype))
                  ww(k)=DBLE(w_as(k,ntyp(itype)))
               END DO
               IF (av.gt.1.D-10) THEN
                  CALL red_spec(ww,y,av,yob,1,iw(itype),law_rd) 
                 DO k=1,iw(itype)
                     y(k)=yob(k)
                  END DO
               END IF
c number of filters + the filter for absolute mag estimates
               DO ilyf=1,nlyf
                  istep=istep+1
                  frac=DBLE(FLOAT(istep)/FLOAT(nsteps))
                  npercent=INT(frac/0.25D0)
                  IF (npercent.gt.npercent0) THEN
                     WRITE(*,'(a,i4,a)') 
     .                    ' Hypercube: ',25*npercent,'% done'
                     npercent0=npercent
                  END IF
                  fact_lyf=r_lyf**(ilyf-1)*(1.D0/r_lyf)
                  DO k=1,iw(itype)
                     yob(k)=y(k)
                  END DO
c ..... Lyman alpha forest
                  CALL lyman_forest(ww,yob,iw(itype),z(i))
                  DO k=0,n_filter
                     flux(k,i,itype,ired,ilyf)=
     .                    filter(nfil(k),ww,yob,iw(itype),z(i))/surf(k)
                  END DO
               END DO
            END DO
         END DO
      END DO

c      WRITE(*,'(1x,a)') '                      ... done'
      part_time=DBLE(cputime())-part_time
      WRITE(*,'(1X,A,F12.3,A)') 'CPU time involved : ',part_time,
     .     ' seconds'
c -----------------------------------------------------------------------
c                          Loop over the objects 
c -----------------------------------------------------------------------
      WRITE(*,'(1x,a)') 'I''m working ...'

      IF (ccat.eq.'y'.or.ccat.eq.'Y') 
     .     OPEN(10,FILE=spectra1,STATUS='unknown',ERR=81)
      IF (clog.eq.'y'.or.clog.eq.'Y')
     .     OPEN(14,FILE=spectra2,STATUS='unknown',ERR=81)
      IF (csed1.eq.'y'.or.csed1.eq.'Y')
     .     OPEN(15,FILE=spectra3,STATUS='unknown',ERR=81)
      IF (cz.eq.'y'.or.cz.eq.'Y')
     .     OPEN(17,FILE=spectra4,STATUS='unknown',ERR=81)
      IF (csed2.eq.'y'.or.csed2.eq.'Y')
     .     OPEN(19,FILE=spectra5,STATUS='unknown',ERR=81)

      WRITE(fmt1,2006) n_filter,n_filter
      WRITE(fmt2,2007) n_filter,n_filter
      WRITE(fmt3,2010) n_filter
      WRITE(fmt4,2011) n_filter
 2006 FORMAT('(1x,i12,',i2,'(1x,F8.4),',i2,'(1x,F8.4))')
 2007 FORMAT('(1x,i12,',i2,'(1x,E11.5),',i2,'(1x,E11.5))')
 2010 FORMAT('(1x,i12,',i2,'(1x,F8.4))')
 2011 FORMAT('(1x,i12,',i2,'(1x,E11.5))')

      OPEN(16,FILE=cat_in,STATUS='old',ERR=79)
c ..... Skipping the header (thanks to V. Le Brun)
      IF (header) THEN
         DO i=1,n_head
            READ(16,'(A)') header_line
         END DO
      END IF

      iob=0
13400 CONTINUE
      iob=iob+1
      IF (icat.eq.0) THEN
         READ(16,*,ERR=13500,END=13500) id,(rmag(i),i=1,n_filter),
     .        (rerr_p(i),i=1,n_filter)
      ELSE IF (icat.eq.1) THEN
         READ(16,*,ERR=13500,END=13500) id,z1,z2,(rmag(i),i=1,n_filter),
     .        (rerr_p(i),i=1,n_filter)
      END IF
     
      DO iii=1,n_filter
         IF (((magtyp.eq.0.or.magtyp.eq.1).and.
     .        (rmag(iii).lt.90.0.and.rmag(iii).gt.1.)).or.
     .        (magtyp.eq.2.and.rmag(iii).ge.0.)) GO TO 13401
      END DO                  
      WRITE(*,*) 'WARNING: non detected object id ', id
c ..... Write outputs in any case (except .m and .spe)
c ..... File .z_phot
      zphot(1)=99.D0
      r_chi2=99.D0
      qq=0.D0
      itypem=0
      iage=0
      age=99.D0
      av=0.D0
      bb(1)=0.D0
      DO i=1,3
         zz1(i)=99.D0
         zz2(i)=99.D0
      END DO
      z_poids=99.D0
      qq_p=0.D0
      amagb=99.D0
      zphot(2)=99.D0
      qq2=0.D0
      amagb_clus=99.D0
      p_clus=0.D0
      amag(1)=99.D0
      i_sol=1
      fact_lyf=1.D0
      IF (z_clus.ge.0.D0) THEN
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),r_chi2,
     .        qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,zphot(2),
     .        qq2,amagb_clus,p_clus,amag(1)
      ELSE
        IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),r_chi2,
     .        qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,
     .        zphot(2),qq2
      END IF
c ..... File .cat_phot
      IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),r_chi2,
     .     qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .     zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol
c ..... File .log_phot
      IF(clog.eq.'y'.or.clog.eq.'Y') THEN
         DO i=1,nz
            WRITE(14,2002) id,z(i),r_chi2,qq,itypem,age,av,fact_lyf
         END DO
      END IF
c ..... File .obs_sed
      IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
         DO i=1,n_filter
            fl1(i)=-1.D0
            err_fl(i)=0.D0
            amag(i)=99.D0
            err_p(i)=99.D0
         END DO
         IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
            WRITE(15,fmt2) id,(fl1(i),i=1,n_filter),
     .           (err_fl(i),i=1,n_filter)
         ELSE IF (iunit_sed.eq.2) THEN
            WRITE(15,fmt1) id,(amag(i),i=1,n_filter),
     .           (err_p(i),i=1,n_filter)
         END IF
      END IF
c ..... File .temp_sed
      IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
         DO k=1,n_filter
            mag_temp(k)=99.D0
            fl_temp(k)=-1.D0
         END DO
         IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
            WRITE(19,fmt4) id,(fl_temp(k),k=1,n_filter)
         ELSE IF (iunit_sed.eq.2) THEN
            WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filter)
         END IF
      END IF

      GO TO 13400
         
c ..... Computing the fluxes (unit 2.E-17) and errors in the filters
13401 iw_ob=0
      DO iii=1,n_filter
         amag(iii)=DBLE(rmag(iii))
         err_p(iii)=DBLE(rerr_p(iii))
         i_lyman(iii)=0
         IF (err_p(iii).lt.err_min) err_p(iii)=err_min
         IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .        (amag(iii).gt.1.D0.and.amag(iii).lt.90.D0).and.
     .        err_p(iii).lt.90.D0) THEN
            iw_ob=iw_ob+1
            IF (magtyp.eq.0) fl(iii)=vega(iii)*
     .           10**(-0.4D0*(amag(iii)+c_corr(iii)))/surf(iii) 
            IF (magtyp.eq.1) fl(iii)=(10**(-0.4D0*(amag(iii)+
     .           c_corr(iii)+48.6D0))*(2.9979D+18/(wl(iii)**2)))/2.D-17 
c            err_fl(iii)=(2.3D0/2.5D0)*fl(iii)*err_p(iii)
            err_fl(iii)=0.4D0*DLOG(10.D0)*fl(iii)*err_p(iii)
c ..... Dereddening
            IF (ebv_mw.ne.0.D0) THEN
               CALL red_spec(wl(iii),fl(iii),av_mw,fl_ext,2,1,1)
               fl(iii)=fl_ext
            END IF
c amag -> Vega magnitude
            IF (magtyp.eq.0) THEN
               amag1(iii)=amag(iii)
            ELSE IF (magtyp.eq.1) THEN
               amag1(iii)=amag(iii)-conv_mag(iii)
            END IF
        ELSE IF (magtyp.eq.2.and.amag(iii).ge.0.D0) THEN ! input in muJy
            iw_ob=iw_ob+1
            f_jy(iii)=amag(iii)
            err_jy(iii)=err_p(iii)
c            fl(iii)=amag(iii)*1.E-29*(2.9979E+18/(wl(iii)**2)))/2.E-17
            fl(iii)=amag(iii)*1.D-12*0.5D0*(2.9979D+18/(wl(iii)**2))
            err_fl(iii)=err_p(iii)*1.D-12*0.5D0*
     .           (2.9979D+18/(wl(iii)**2))
c ..... Dereddening
            IF (ebv_mw.ne.0.D0) THEN
               CALL red_spec(wl(iii),fl(iii),av_mw,fl_ext,2,1,1)
               fl(iii)=fl_ext
            END IF
c amag: flux[muJy] -> Vega magnitude
            amag1(iii)=-2.5D0*DLOG10(fl(iii)*surf(iii)/vega(iii)) 
c magnitude is an upper limit, use non detection law 2
         ELSE IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .           (amag(iii).gt.1.D0.and.amag(iii).lt.90.D0).and.
     .           err_p(iii).gt.90.D0) THEN
            iw_ob=iw_ob+1
            IF (magtyp.eq.0) fl(iii)=vega(iii)*
     .           10**(-0.4D0*(amag(iii)+c_corr(iii)))/surf(iii) 
            IF (magtyp.eq.1) fl(iii)=(10**(-0.4D0*(amag(iii)+
     .           c_corr(iii)+48.6D0))*(2.9979D+18/(wl(iii)**2)))/2.D-17 
c ..... Dereddening
            IF (ebv_mw.ne.0.D0) THEN
               CALL red_spec(wl(iii),fl(iii),av_mw,fl_ext,2,1,1)
               fl(iii)=fl_ext
            END IF
c imposing non detection law 2
            fl(iii)=fl(iii)/2.D0
            err_fl(iii)=fl(iii)
            i_lyman(iii)=1
c amag -> Vega magnitude
            IF (magtyp.eq.0) THEN
               amag1(iii)=amag(iii)
            ELSE IF (magtyp.eq.1) THEN
               amag1(iii)=amag(iii)-conv_mag(iii)
            END IF
         ELSE IF (magtyp.eq.2.and.amag(iii).ge.0..and.
     .           err_p(iii).lt.0.) THEN 
            iw_ob=iw_ob+1
            fl(iii)=amag(iii)*1.D-12*0.5D0*(2.9979D+18/(wl(iii)**2))
            IF (ebv_mw.ne.0.) THEN
               CALL red_spec(wl(iii),fl(iii),av_mw,fl_ext,2,1,1)
               fl(iii)=fl_ext
            END IF
            amag1(iii)=-2.5D0*DLOG10(fl(iii)*surf(iii)/vega(iii)) 
c imposing non detection law 2
            fl(iii)=fl(iii)/2.D0
            err_fl(iii)=fl(iii)
            f_jy(iii)=amag(iii)/2.D0
            err_jy(iii)=f_jy(iii)
            i_lyman(iii)=1
         ELSE IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .           amag(iii).le.1.D0) THEN ! out of file objects
            fl(iii)=-1.0D0
            err_fl(iii)=0.0D0
            amag1(iii)=-1.0D0
         ELSE IF (magtyp.eq.2.and.ABS(amag(iii)+1.D0).lt.1.D-6) THEN 
            fl(iii)=-1.0D0
            err_fl(iii)=0.0D0
            amag1(iii)=-1.0D0
            f_jy(iii)=-1.0D0
            err_jy(iii)=0.0D0
         ELSE IF (((magtyp.eq.0.or.magtyp.eq.1).and.
     .           amag(iii).ge.90.D0).or.
     .           (magtyp.eq.2.and.amag(iii).lt.-90.D0)) THEN ! non detected objs
            IF (law_nd(iii).eq.0) THEN
               fl(iii)=-1.0D0
               err_fl(iii)=0.D0
               amag1(iii)=99.D0
               f_jy(iii)=-1.0D0
               err_jy(iii)=0.D0
            ELSE IF (law_nd(iii).eq.1) THEN
               fl(iii)=0.D0
               err_fl(iii)=fl_nd(iii)
               amag1(iii)=99.D0
               i_lyman(iii)=2
               iw_ob=iw_ob+1
            ELSE IF (law_nd(iii).eq.2) THEN
               fl(iii)=fl_nd(iii)/2.D0
               err_fl(iii)=fl(iii)
               amag1(iii)=99.D0
               i_lyman(iii)=1
               iw_ob=iw_ob+1
            ELSE IF (law_nd(iii).eq.3) THEN
               fl(iii)=fl_nd(iii)
               err_p(iii)=err_nd(iii)
               amag1(iii)=99.D0
               IF (magtyp.eq.0.or.magtyp.eq.1) THEN
c                  err_fl(iii)=(2.3/2.5)*fl(iii)*err_p(iii)
                  err_fl(iii)=0.4D0*DLOG(10.D0)*fl(iii)*err_p(iii)
               ELSE
                  err_fl(iii)=err_nd(iii)*1.D-12*0.5D0*
     .                 (2.9979D+18/(wl(iii)**2))
               END IF
               i_lyman(iii)=1
               iw_ob=iw_ob+1
            END IF
         END IF
      END DO

      ndeg=iw_ob-1  ! degrees of freedom
      deg=DBLE(REAL(ndeg))

      IF (ndeg.lt.1) THEN
         WRITE(*,*) 'WARNING: impossible to compute object ', iob
c ..... Write outputs in any case (except .m and .spe)
c ..... File .z_phot
         zphot(1)=99.D0
         r_chi2=99.D0
         qq=0.D0
         itypem=0
         iage=0
         age=99.D0
         av=0.D0
         bb(1)=0.D0
         DO i=1,3
            zz1(i)=99.D0
            zz2(i)=99.D0
         END DO
         z_poids=99.D0
         qq_p=0.D0
         amagb=99.D0
         zphot(2)=99.D0
         qq2=0.D0
         amagb_clus=99.D0
         p_clus=0.D0
         amag(1)=99.D0
         i_sol=1
         fact_lyf=1.D0
         IF (z_clus.ge.0.D0) THEN
            IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),
     .           r_chi2,qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),
     .           zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .           fact_lyf,zphot(2),qq2,amagb_clus,p_clus,amag(1)
         ELSE
            IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),
     .           r_chi2,qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),
     .           zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .           fact_lyf,zphot(2),qq2
         END IF
c ..... File .cat_phot
         IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),
     .        r_chi2,qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol
c ..... File .log_phot
         IF(clog.eq.'y'.or.clog.eq.'Y') THEN
            DO i=1,nz
               WRITE(14,2002) id,z(i),r_chi2,qq,itypem,age,av,fact_lyf
            END DO
         END IF
c ..... File .obs_sed
         IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
            DO i=1,n_filter
               fl1(i)=-1.D0
               err_fl(i)=0.D0
               amag(i)=99.D0
               err_p(i)=99.D0
            END DO
            IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
               WRITE(15,fmt2) id,(fl1(i),i=1,n_filter),
     .              (err_fl(i),i=1,n_filter)
            ELSE IF (iunit_sed.eq.2) THEN
               WRITE(15,fmt1) id,(amag(i),i=1,n_filter),
     .              (err_p(i),i=1,n_filter)
            END IF
         END IF
c ..... File .temp_sed
         IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
            DO k=1,n_filter
               mag_temp(k)=99.D0
               fl_temp(k)=-1.D0
            END DO
            IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
               WRITE(19,fmt4) id,(fl_temp(k),k=1,n_filter)
            ELSE IF (iunit_sed.eq.2) THEN
               WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filter)
            END IF
         END IF

         GO TO 13400
      END IF
      
c -----------------------------------------------------------------------
c                         Computation 
c -----------------------------------------------------------------------

c ..... Open file for the matrix of results (if case)

      matrix=0
      WRITE(root,'(i8)') id
      DO k=1,8
         IF (root(k:k).ne.' ') THEN
            root=root(k:)
            GO TO 22
         END IF
      END DO
 22   iroot=INDEX(root,' ')-1
      IF (iout_m.gt.1) THEN
         amatrix=root(1:iroot)//'.m'
         matrix=1
         OPEN(11,FILE=amatrix,STATUS='unknown')
      END IF

      IF (icat.eq.1) THEN
         DO i=1,nz-1
            IF (z1.ge.z(i).and.z1.lt.z(i+1)) i1=i
            IF (z2.gt.z(i).and.z2.le.z(i+1)) i2=i+1
         END DO
         IF (z2.gt.z(nz)) i2=nz
      ELSE IF (icat.eq.0) THEN
         i1=1
         i2=nz
      END IF

      IF (z_clus.ge.0.D0) THEN
         DO i=1,nz-1
            IF (z_clus.ge.z(i).and.z_clus.lt.z(i+1)) iz_clus=i
         END DO
         IF (z_clus.eq.z(nz)) iz_clus=nz
      END IF
      age=19.9999D0
      iage=1
c -----------------------------------------------------------------------
      DO i=i1,i2                                 !Scan in z
c -----------------------------------------------------------------------
         z_min_array(i)=1.D+30
         i_typ(i)=1
         i_red(i)=1
         dif_w_min=1.D12
         n_fil_wa=1
         DO k=1,n_filter
            dif_w=ABS(wl(k)-wl(0)*(z_clus+1.D0))
            IF (((magtyp.eq.0.or.magtyp.eq.1).and.
     .           (amag(k).gt.1.D0.and.amag(k).lt.90.D0)).or.
     .           (magtyp.eq.2.and.amag(k).gt.0.D0)) THEN
               IF (dif_w.lt.dif_w_min) THEN 
                  dif_w_min=dif_w
                  n_fil_wa=k
               END IF
            END IF
         END DO
c -----------------------------------------------------------------------
         DO itype=1,n_files     !Scan types
c -----------------------------------------------------------------------
            DO ired=1,nred      ! Scan reddening
c -----------------------------------------------------------------------
               DO ilyf=1,nlyf   ! Scan Lyman Forest
                  fact_lyf=r_lyf**(ilyf-1)*(1.D0/r_lyf)
c -----------------------------------------------------------------------
                  av=avmin+(ired-1)*averr
                  sxx=0.D0
                  sxy=0.D0
                  b=0.D0

c ..... Probability for z(i), itype, ired, ilyf

                  DO k=1,n_filter
                     IF (fl(k).ge.0.) THEN ! no oof objects
                        IF (flux(k,i,itype,ired,ilyf).lt.1.D-12
     .                       .and.i_lyman(k).eq.1) THEN
                           fl1(k)=0.D0
                        ELSE
                           fl1(k)=fl(k)
                           wt=1.D0/(err_fl(k)**2)
                           sxx=sxx+flux(k,i,itype,ired,ilyf)
     .                          *flux(k,i,itype,ired,ilyf)*wt
                           sxy=sxy+fl1(k)*wt*flux(k,i,itype,ired,ilyf)
                        END IF
                     ELSE
                        fl1(k)=-1.D0
                     END IF
                  END DO
                  b=sxy/sxx
                  chi2=0.D0
                  DO k=1,n_filter
                     IF (fl1(k).ge.0.D0) THEN ! no oof obj.
                        chi2=chi2+((fl1(k)-b*flux(k,i,itype,ired,ilyf))
     .                       /err_fl(k))**2
                     END IF
                  END DO
                  IF (fact_lyf.eq.1..and. ! average Ly for. preferred value
     .                 ABS(chi2-z_min_array(i)).lt.err) THEN
                     z_min_array(i)=chi2
                     bb_array(i)=b
                     i_typ(i)=itype
                     i_red(i)=ired
                     i_lyf(i)=ilyf
                  ELSE IF (chi2-z_min_array(i).lt.0.) THEN
                     z_min_array(i)=chi2
                     bb_array(i)=b
                     i_typ(i)=itype
                     i_red(i)=ired
                     i_lyf(i)=ilyf
                  END IF
                  IF (z_clus.ge.0..and.i.eq.iz_clus) THEN
                     itypea=itype
                     ireda=ired
                     ilyfa=ilyf
                  END IF

                  IF (matrix.gt.0) THEN
                     r_chi2=chi2/deg ! reduced chi2
                     WRITE(11,2012) id,z(i),itype,iage,age,av,
     .                    fact_lyf,r_chi2
                  END IF
               END DO
            END DO
         END DO

         q_pro(i)=100.D0*qchi2(0.5D0*deg,0.5D0*z_min_array(i))
         
         r_chi2=z_min_array(i)/deg ! reduced chi2
         fact_lyf=r_lyf**(i_lyf(i)-1)*(1.D0/r_lyf)

         IF(clog.eq.'y'.or.clog.eq.'Y') THEN
            WRITE(14,2002) id,z(i),r_chi2,q_pro(i),i_typ(i),age,
     .                     avmin+(i_red(i)-1)*averr,fact_lyf
         END IF
         
      END DO
      CLOSE(11)                 !close output matrix

c -----------------------------------------------------------------------
c                     End scan
c -----------------------------------------------------------------------
c ..... Searching minima of chi2

      n_sol=0
      DO i=i1,i2
         dif_w_min=1.D12
         n_fil_w(i)=1
         DO k=1,n_filter
            dif_w=ABS(wl(k)-wl(0)*(z(i)+1.D0))
            IF ((magtyp.eq.0.or.magtyp.eq.1).and.
     .           amag(k).gt.1.D0.and.amag(k).lt.90.D0
     .           .and.i_lyman(k).lt.1) THEN
               IF (dif_w.lt.dif_w_min) THEN   
                  dif_w_min=dif_w 
                  n_fil_w(i)=k  
               END IF
            ELSE IF (magtyp.eq.2.and.amag(k).ge.0.D0) THEN
               IF (dif_w.lt.dif_w_min) THEN   
                  dif_w_min=dif_w 
                  n_fil_w(i)=k  
               END IF
            END IF
         END DO
         dd=1.D0
         IF (i.eq.i1) THEN
            dd=z_min_array(i1)-z_min_array(i1+1)
            d1=z_min_array(i1)-z_min_array(i1+1)
         ELSE IF (i.eq.i2) THEN
            dd=z_min_array(i2)-z_min_array(i2-1)
            d1=z_min_array(i2)-z_min_array(i2-1)
         ELSE
            d1=z_min_array(i)-z_min_array(i-1)
            d2=z_min_array(i+1)-z_min_array(i)
            IF (d1.ne.0.D0) dd=d2/d1
         END IF
         IF (dd.le.0.D0.and.d1.lt.0.D0) THEN ! dd < 0 extrema
            n_sol=n_sol+1
            izphot(n_sol)=i
         END IF
      END DO

c ..... Refinement around minima
      DO i=1,n_sol
         izsol=izphot(i)
         IF (izsol.eq.i1) THEN
            dz_f=(z(izsol+1)-z(izsol))/10.D0
            zmax_f=z(izsol+1)
            zmin_f=z(izsol)
         ELSE IF (izsol.eq.i2) THEN
            dz_f=(z(izsol)-z(izsol-1))/10.D0
            zmax_f=z(izsol)
            zmin_f=z(izsol-1)
         ELSE
            dz_f=(z(izsol+1)-z(izsol-1))/20.D0
            zmax_f=z(izsol+1)
            zmin_f=z(izsol-1)
         END IF
         IF (zmin_f.lt.z(i1)) zmin_f=z(i1)
         IF (zmax_f.gt.z(i2)) zmax_f=z(i2)
         av=avmin+(i_red(izsol)-1)*averr
         fact_lyf=r_lyf**(i_lyf(izsol)-1)*(1.D0/r_lyf)
         CALL zfit_min(i_typ(izsol),av,zmin_f,zmax_f,dz_f,chi2,zop)
         IF (izsol.eq.i1.or.izsol.eq.i2) THEN 
            IF (chi2.lt.z_min_array(izsol)) THEN
               zphot(i)=zop
               chi2sol(i)=chi2
               bb(i)=bm
            ELSE 
               zphot(i)=z(izsol)
               chi2sol(i)=z_min_array(izsol)
               bb(i)=bb_array(izsol)
            END IF
         ELSE
            zphot(i)=zop
            chi2sol(i)=chi2
            bb(i)=bm
         END IF
      END DO

c ..... Ordering solutions
      DO i=2,n_sol
         IF (chi2sol(i).lt.chi2sol(i-1)) THEN
            DO j=i-1,1,-1
               IF (chi2sol(j+1).lt.chi2sol(j)) THEN
                  dummy=chi2sol(j+1)
                  chi2sol(j+1)=chi2sol(j)
                  chi2sol(j)=dummy
                  dummy=zphot(j+1)
                  zphot(j+1)=zphot(j)
                  zphot(j)=dummy
                  idum=izphot(j+1)
                  izphot(j+1)=izphot(j)
                  izphot(j)=idum
                  ddummy=bb(j+1)
                  bb(j+1)=bb(j)
                  bb(j)=ddummy
               END IF
            END DO
         END IF
      END DO

c ..... Check absolute magnitude of the first solution
c       if amagb not in [amabs_1,amabs_2] search the next 
c       solution satisfying constraint
      DO i=1,nz
         iforbid(i)=0
      END DO
      iz=izphot(1)
c absolute magnitude
      amagb=0.0D0
      bmag=1000.0D0
      sauce=flux(n_fil_w(iz),iz,i_typ(iz),i_red(iz),i_lyf(iz))
     .     /flux(n_fil_w(iz),0,i_typ(iz),i_red(iz),i_lyf(iz))
      IF (sauce.gt.0.0) bmag=amag1(n_fil_w(iz))+ ! absolute k magnitude
     .     2.5D0*DLOG10(sauce)-d_mod(h0,om,ov,z(iz)) 
      sauce=flux(0,0,i_typ(iz),i_red(iz),i_lyf(iz))*surf(0)
      IF (sauce.gt.0.0) amagb=bmag-(zeropoint(n_fil_w(iz))-
     .     2.5D0*DLOG10(flux(n_fil_w(iz),0,i_typ(iz),i_red(iz),
     .     i_lyf(iz))*surf(n_fil_w(iz))/sauce)) 
      IF (magtyp.eq.1) amagb=amagb+conv_mag(0)
c constraint absolute magnitude
      IF (amagb.ge.amabs_1.and.amagb.le.amabs_2) GO TO 2000 ! solution ok
c first solution forbidden, search the next one
      iforbid(iz)=1
 200  chi2min=1.D6
      DO i=i1,i2
         IF (z_min_array(i).lt.chi2min.and.iforbid(i).ne.1) THEN
            chi2min=z_min_array(i)
            iz=i
         END IF
      END DO

      DO i=1,n_sol
         IF (iz.eq.izphot(i)) THEN 
c check the absolute magnitude for the i-th solution
            amagb=0.0D0
            bmag=1000.0D0
            sauce=flux(n_fil_w(iz),iz,i_typ(iz),i_red(iz),
     .           i_lyf(iz))/flux(n_fil_w(iz),0,i_typ(iz),
     .           i_red(iz),i_lyf(iz))
            IF (sauce.gt.0.0) bmag=amag1(n_fil_w(iz))+ ! absolute k magnitude
     .           2.5D0*DLOG10(sauce)-d_mod(h0,om,ov,z(iz)) 
            sauce=flux(0,0,i_typ(iz),i_red(iz),i_lyf(iz))
     .           *surf(0)
            IF (sauce.gt.0.0) amagb=bmag-(zeropoint(n_fil_w(iz))-
     .           2.5D0*DLOG10(flux(n_fil_w(iz),0,i_typ(iz),
     .           i_red(iz),i_lyf(iz))*surf(n_fil_w(iz))/sauce)) 
            IF (magtyp.eq.1) amagb=amagb+conv_mag(0)
c constraint absolute magnitude
c i-th solution ok -> re-order solutions
            IF (amagb.ge.amabs_1.and.amagb.le.amabs_2) THEN
               GO TO 3000
            ELSE
c i-th solution forbidden
               iforbid(iz)=1
               GO TO 200
            END IF 
         END IF
      END DO

c refinement if the new minimum is not a secondary solution
      IF (iz.eq.i1) THEN
         dz_f=(z(iz+1)-z(iz))/10.D0
         zmax_f=z(iz+1)
         zmin_f=z(iz)
      ELSE IF (iz.eq.i2) THEN
         dz_f=(z(iz)-z(iz-1))/10.D0
         zmax_f=z(iz)
         zmin_f=z(iz-1)
      ELSE
         dz_f=(z(iz+1)-z(iz-1))/20.D0
         zmax_f=z(iz+1)
         zmin_f=z(iz-1)
      END IF
      IF (zmin_f.lt.z(i1)) zmin_f=z(i1)
      IF (zmax_f.gt.z(i2)) zmax_f=z(i2)
      av=avmin+(i_red(iz)-1)*averr
      fact_lyf=r_lyf**(i_lyf(iz)-1)*(1.D0/r_lyf)
      CALL zfit_min(i_typ(iz),av,zmin_f,zmax_f,dz_f,chi2,zop)
c check absolute magnitude
      amagb=0.0D0
      bmag=1000.0D0
      sauce=flux(n_fil_w(iz),iz,i_typ(iz),i_red(iz),i_lyf(iz))
     .     /flux(n_fil_w(iz),0,i_typ(iz),i_red(iz),i_lyf(iz))
      IF (sauce.gt.0.0) bmag=amag1(n_fil_w(iz))+ 
     .     2.5D0*DLOG10(sauce)-d_mod(h0,om,ov,z(iz)) 
      sauce=flux(0,0,i_typ(iz),i_red(iz),i_lyf(iz))*surf(0)
      IF (sauce.gt.0.0D0) amagb=bmag-(zeropoint(n_fil_w(iz))-
     .     2.5D0*DLOG10(flux(n_fil_w(iz),0,i_typ(iz),i_red(iz),
     .     i_lyf(iz))*surf(n_fil_w(iz))/sauce)) 
      IF (magtyp.eq.1) amagb=amagb+conv_mag(0)
      IF (amagb.ge.amabs_1.and.amagb.le.amabs_2) THEN
c found new first solution, add solution and shift the others
         n_sol=n_sol+1
         DO i=n_sol,2,-1
            chi2sol(i)=chi2sol(i-1)
            zphot(i)=zphot(i-1)
            izphot(i)=izphot(i-1)
            bb(i)=bb(i-1)
         END DO
         zphot(1)=zop
         chi2sol(1)=chi2
         bb(1)=bm
         izphot(1)=iz
         GO TO 2000
      ELSE 
         IF (iz.ne.i2) THEN
c forbidden solution, try again
            iforbid(iz)=1
            GO TO 200
         ELSE
            WRITE(*,'(1x,a,i9)') 'WARNING: impossible to find a '//
     .           'solution within constraints for object ', id
c ..... Write outputs in any case (except .m and .spe)
c ..... File .z_phot
            zphot(1)=-9.9D0
            r_chi2=99.D0
            qq=0.D0
            itypem=0
            iage=0
            age=99.D0
            av=0.D0
            bb(1)=0.D0
            DO i=1,3
               zz1(i)=99.D0
               zz2(i)=99.D0
            END DO
            z_poids=99.D0
            qq_p=0.D0
            amagb=99.D0
            zphot(2)=99.D0
            qq2=0.D0
            amagb_clus=99.D0
            p_clus=0.D0
            amag(1)=99.D0
            i_sol=1
            fact_lyf=1.D0
            IF (z_clus.ge.0.D0) THEN
               IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),
     .              r_chi2,qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),
     .              zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .              fact_lyf,zphot(2),qq2,amagb_clus,p_clus,amag(1)
            ELSE
               IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),
     .              r_chi2,qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),
     .              zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .              fact_lyf,zphot(2),qq2
            END IF
c ..... File .cat_phot
            IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),
     .           r_chi2,qq,itypem,iage,age,av,bb(1),zz1(1),zz2(1),
     .           zz1(2),zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,
     .           fact_lyf,i_sol
c ..... File .obs_sed
            IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
               IF (iunit_sed.eq.0) THEN
                  WRITE(15,fmt2) id,(fl1(i),i=1,n_filter),
     .                 (err_fl(i),i=1,n_filter)
               ELSE IF (iunit_sed.eq.1) THEN
                  IF (magtyp.eq.0.or.magtyp.eq.1) THEN
                     DO k=1,n_filter
                        f_jy(k)=fl1(k)*2.D-17*
     .                       (wl(k)**2/(2.9979D+18))*1.D+29
c                        err_jy(k)=(2.3/2.5)*f_jy(k)*err_p(k)
                        err_jy(k)=0.4D0*DLOG(10.D0)*f_jy(k)*err_p(k)
                     END DO
                  END IF
                  WRITE(15,fmt2) id,(f_jy(i),i=1,n_filter),
     .                 (err_jy(i),i=1,n_filter)
               ELSE IF (iunit_sed.eq.2) THEN
                  IF (magtyp.eq.0.or.magtyp.eq.1) THEN
                     DO k=1,n_filter
                        IF (amag(k).gt.90.D0) THEN
                           amag(k)=mag_nd(k)+conv_mag(k)
                           err_p(k)=99.D0
                        ELSE IF (amag1(k).lt.1.D0) THEN
                           amag(k)=-1.D0
                           err_p(k)=-1.D0
                        ELSE
                           amag(k)=amag1(k)+conv_mag(k)
                        END IF
                     END DO
                  ELSE IF (magtyp.eq.2) THEN
                     DO k=1,n_filter
                        IF (amag(k).lt.-90.D0) THEN
                           err_p(k)=99.D0
                           amag(k)=mag_nd(k)+conv_mag(k)
                        ELSE IF (ABS(amag(iii)+1.D0).lt.1.D-6) THEN
                           amag(k)=-1.D0
                           err_p(k)=-1.D0
                        ELSE
c                           err_p(k)=2.5D0/2.3D0*err_p(k)/amag(k)
                           err_p(k)=2.5D0/DLOG(10.D0)*err_p(k)/amag(k)
                           amag(k)=amag1(k)+conv_mag(k)
                        END IF
                     END DO
                  END IF
                  WRITE(15,fmt1) id,(amag(i),i=1,n_filter),
     .                 (err_p(i),i=1,n_filter)
               END IF
            END IF
c ..... File .temp_sed
            IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
               DO k=1,n_filter
                  mag_temp(k)=99.D0
                  fl_temp(k)=-1.D0
               END DO
               IF (iunit_sed.eq.0.or.iunit_sed.eq.1) THEN
                  WRITE(19,fmt4) id,(fl_temp(k),k=1,n_filter)
               ELSE IF (iunit_sed.eq.2) THEN
                  WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filter)
               END IF
            END IF
            GO TO 13400
         END IF
      END IF

c re-ordering
 3000 izmin=izphot(i)
      dummy=chi2sol(i)
      dummyz=zphot(i)
      idum=izphot(i)
      ddummy=bb(i)
      i_sol=i
      DO i=i_sol,2,-1
         chi2sol(i)=chi2sol(i-1)
         zphot(i)=zphot(i-1)
         izphot(i)=izphot(i-1)
         bb(i)=bb(i-1)
      END DO
      chi2sol(1)=dummy
      zphot(1)=dummyz
      izphot(1)=idum
      bb(1)=ddummy

c ..... main solution 
 2000 i_sol=1
      izmin=izphot(1)
      itypem=i_typ(izmin)
      iage=1
      age=19.9999D0
      iredm=i_red(izmin)
      av=avmin+(iredm-1)*averr
      ilyfm=i_lyf(izmin)
      fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)
      DO k=1,n_filter
         IF (ABS(flux(k,izmin,itypem,iredm,ilyfm)).lt.1.D-12.and.
     .        i_lyman(k).eq.1) THEN
            fl1(k)=0.D0
         ELSE 
            fl1(k)=fl(k)
         END IF
      END DO
      r_chi2=chi2sol(1)/deg
      IF (r_chi2.ge.1.D4) r_chi2=9999.99D0
      qq=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(1))      
      IF (z(izmin)-zphot(1).gt.0.5D0*dz_f) THEN
         izmin1=izmin-1
      ELSE
         izmin1=izmin
      END IF

c ..... study of confidence intervals
      DO i=1,3
         zz1(i)=z(i1)
         zz2(i)=z(i2)
      END DO
      DO i=1,mxz
         q_pro1(i)=0.D0
         q_pro2(i)=0.D0
         q_proz(i)=0.D0
      END DO
      poids=0.0D0
      poids_z=0.0D0
      z_poids=0.D0
      qq_p=0.D0

c ..... Values after izmin
      z_b1(1)=zphot(1)
      chi2_b1(1)=chi2sol(1)
      q_pro1(1)=qq
      i=izmin1+1
      npoiz1=1
      IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5.and.izmin1.eq.i2) THEN
         DO ii=1,3              ! z at P = 99 90 and 68%
            zz2(ii)=z(i2)
         END DO
         npoiz1=1
      ELSE
 1001    CONTINUE
         k=i-izmin1+1
         q_pro1(k)=q_pro(i)
         z_b1(k)=z(i)
         chi2_b1(k)=z_min_array(i)

         IF (i.lt.i2.and.i.le.izmin1) THEN
            i=i+1
            GO TO 1001
         ELSE IF (i.lt.i2.and.(chi2_b1(k)-chi2sol(1)).le.val(1)) THEN
            i=i+1
            GO TO 1001
         END IF
         npoiz1=k

         DO ii=1,3              ! z at P = 99 90 and 68%
            l=0
            zz2(ii)=rlin(val(ii)+chi2sol(1),chi2_b1,z_b1,npoiz1,l)
            IF (zz2(ii).lt.z(i1)) zz2(ii)=z(i1)
            IF (zz2(ii).gt.z(i2)) zz2(ii)=z(i2)
            IF (zz2(ii).lt.zphot(1)) zz2(ii)=z2
         END DO
      END IF

c ..... Values before izmin

      z_b2(1)=zphot(1)
      chi2_b2(1)=chi2sol(1)
      i=izmin1
      ipass=0
      npoiz2=1
      IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5) THEN
         q_pro2(1)=q_pro(izmin1)
         ipass=1
      END IF
      IF (ABS(z(izmin1)-zphot(1)).lt.1.e-5.and.izmin1.eq.i1) THEN
         DO ii=1,3                 !z at P = 99 90 and 68%
            zz1(ii)=z(i1)
         END DO
         npoiz2=1
      ELSE
 1003    CONTINUE
         k=izmin1-i+2
         q_pro2(k)=q_pro(i-ipass)
         z_b2(k)=z(i-ipass)
         chi2_b2(k)=z_min_array(i-ipass)
         IF (i-ipass.gt.1.and.i-ipass.ge.izmin1) THEN
            i=i-1
            GO TO 1003
         ELSE IF (i-ipass.gt.1.and.
     .           (chi2_b2(k)-chi2sol(1)).le.val(1)) THEN
            i=i-1
            GO TO 1003
         END IF
         npoiz2=k

         DO ii=1,3                 !z at P = 99 90 and 68%
         l=0
            zz1(ii)=rlin(val(ii)+chi2sol(1),chi2_b2,z_b2,npoiz2,l)
            IF (zz1(ii).lt.z(i1)) zz1(ii)=z(i1)
            IF (zz1(ii).gt.z(i2)) zz1(ii)=z(i2)
            IF (zz1(ii).gt.zphot(1)) zz1(ii)=zphot(1)
         END DO
      END IF

c ..... Ordering q_proz et z_b

      IF (ABS(z(izmin1)-zphot(1)).lt.1.e-5.and.izmin1.eq.i1) THEN
         npoiz=npoiz1           ! points after only 
         DO ii=1,npoiz
            q_proz(ii)=q_pro1(ii)
            z_b(ii)=z_b1(ii)
         END DO         
      ELSE IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5.and.izmin1.eq.i2) THEN
         npoiz=npoiz2           ! points before only  
         DO ii=1,npoiz
            q_proz(ii)=q_pro2(npoiz2-(ii-1))
            z_b(ii)=z_b2(npoiz2-(ii-1))
         END DO         
      ELSE IF (ABS(z(izmin1)-zphot(1)).lt.1.D-5.and.
     .        izmin1.ne.1.and.izmin1.ne.i2) THEN
         npoiz=npoiz1+npoiz2-1
         DO ii=1,npoiz2         ! points before
            q_proz(ii)=q_pro2(npoiz2-(ii-1))
            z_b(ii)=z_b2(npoiz2-(ii-1))
         END DO
         DO ii=1,npoiz1-1       ! points after (skip zphot(1))
            q_proz(npoiz2+ii)=q_pro1(ii+1)
            z_b(npoiz2+ii)=z_b1(ii+1)
         END DO
      ELSE
         npoiz=npoiz1+npoiz2-2
         DO ii=1,npoiz2-1       ! points before (skip zphot(1))
            q_proz(ii)=q_pro2(npoiz2-(ii-1))
            z_b(ii)=z_b2(npoiz2-(ii-1))
         END DO
         DO ii=1,npoiz1-1       ! points after (skip zphot(1))
            q_proz(npoiz2+ii-1)=q_pro1(ii+1)
            z_b(npoiz2+ii-1)=z_b1(ii+1)
         END DO
      END IF

      DO ii=1,npoiz
         poids=poids+q_proz(ii)
         poids_z=poids_z+q_proz(ii)*z_b(ii)
      END DO

c ..... z weighted mean

      IF (poids.gt.0.0D0) THEN
         z_poids=poids_z/poids
         l=0
         qq_p=rlin(z_poids,z_b,q_proz,npoiz,l)
      ELSE
         z_poids=zphot(1)
         qq_p=qq
      END IF

c ..... secondary solution
      IF (n_sol.lt.2) THEN      ! no secondary solution
         zphot(2)=9.999D0
         qq2=0.D0
      ELSE
         qq2=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(2))
      END IF

      IF (sed_abc(itypem).eq.'AS'.or.sed_abc(itypem).eq.'A ') THEN
         bbb=bb(1)/rnorm_as(ntyp(itypem))
      ELSE 
         bbb=bb(1)
      END IF

c ..... Probability to be in the cluster
      IF (z_clus.ge.0.D0) THEN
         IF (z_clus.eq.z(iz_clus)) THEN
            p_clus=q_pro(iz_clus)
         ELSE
            p_clus=q_pro(iz_clus)+(q_pro(iz_clus+1)-q_pro(iz_clus))
     .           *(z_clus-z(iz_clus))/(z(iz_clus+1)-z(iz_clus))
         END IF

c ..... Absolute magnitude in the cluster
         DO k=1,iw(itypea)
            y(k)=f_as(k,ntyp(itypea))
            ww(k)=DBLE(w_as(k,ntyp(itypea)))
         END DO

         IF (avmin+(ireda-1)*averr.gt.0.D0) THEN
            CALL red_spec(ww,y,av,yob,1,iw(itypea),law_rd)
            DO k=1,iw(itypea)
               y(k)=yob(k)
            END DO
         END IF
         fact_lyf=r_lyf**(ilyfa-1)*(1.D0/r_lyf)
         CALL lyman_forest(ww,y,iw(itypea),z_clus)
         bmag=amag(n_fil_wa)-d_mod(h0,om,ov,z_clus)+2.5D0*
     .        DLOG10(filter(nfil(n_fil_wa),ww,y,iw(itypea),z_clus)/
     .        filter(nfil(n_fil_wa),ww,y,iw(itypea),0.D0))
         amagb_clus=bmag-zeropoint(n_fil_wa)
     .        +2.5D0*DLOG10(filter(nfil(n_fil_wa),ww,y,iw(itypea),0.D0)/
     .        filter(nfilt_mabs,ww,y,iw(itypea),0.D0))
c         IF (magtyp.eq.1) amagb=amagb+conv_mag(0)

c ..... writing output files
         fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2009) id,zphot(1),r_chi2,
     .        qq,itypem,iage,age,av,bbb,zz1(1),zz2(1),zz1(2),
     .        zz2(2),zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,
     .        zphot(2),qq2,amagb_clus,p_clus,amag(n_fil_wa)
      ELSE
         IF (cz.eq.'y'.or.cz.eq.'Y') WRITE(17,2008) id,zphot(1),r_chi2,
     .        qq,itypem,iage,age,av,bbb,zz1(1),zz2(1),zz1(2),zz2(2),
     .        zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,zphot(2),qq2
      END IF

      IF (ccat.eq.'y'.or.ccat.eq.'Y') WRITE(10,2001) id,zphot(1),r_chi2,
     .     qq,itypem,iage,age,av,bbb,zz1(1),zz2(1),zz1(2),zz2(2),
     .     zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol

c -------------------------------------------------------------------------

c ..... other solutions (if .cat_phot requested, check threshold)

      IF (ccat.eq.'y'.or.ccat.eq.'Y') THEN
         DO i_sol=2,n_sol
            qq=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(i_sol))
            IF (qq.ge.pthresh) THEN
               izmin=izphot(i_sol)
               age=19.9999D0
               iage=1
               r_chi2=chi2sol(i_sol)/deg
               IF (r_chi2.ge.1.D4) r_chi2=9999.99D0
               qq=100.D0*qchi2(0.5D0*deg,0.5D0*chi2sol(i_sol))      
               IF (z(izmin)-zphot(i_sol).gt.0.5D0*dz_f) THEN
                  izmin1=izmin-1
               ELSE
                  izmin1=izmin
               END IF

c ..... study of confidence intervals
               DO i=1,3
                  zz1(i)=z(i1)
                  zz2(i)=z(i2)
               END DO
               DO i=1,mxz
                  q_pro1(i)=0.D0
                  q_pro2(i)=0.D0
                  q_proz(i)=0.D0
               END DO
               poids=0.0D0
               poids_z=0.0D0
               z_poids=0.D0
               qq_p=0.D0

c ..... Values after izmin
               z_b1(1)=zphot(i_sol)
               chi2_b1(1)=chi2sol(i_sol)
               q_pro1(1)=qq
               i=izmin1+1
               npoiz1=1
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.D-5.and.
     .              izmin1.eq.i2) THEN
                  DO ii=1,3     ! z at P = 99 90 and 68%
                     zz2(ii)=z(i2)
                  END DO
                  npoiz1=1
               ELSE
 1002             CONTINUE
                  k=i-izmin1+1
                  q_pro1(k)=q_pro(i)
                  z_b1(k)=z(i)
                  chi2_b1(k)=z_min_array(i)

                  IF (i.lt.i2.and.i.le.izmin1) THEN
                     i=i+1
                     GO TO 1002
                  ELSE IF (i.lt.i2.and.
     .                    (chi2_b1(k)-chi2sol(i_sol)).le.val(1)) THEN
                     i=i+1
                     GO TO 1002
                  END IF
                  npoiz1=k

                  DO ii=1,3     ! z at P = 99 90 and 68%
                     l=0
                     zz2(ii)=rlin(val(ii)+chi2sol(i_sol),
     .                    chi2_b1,z_b1,npoiz1,l)
                     IF (zz2(ii).lt.z(i1)) zz2(ii)=z(i1)
                     IF (zz2(ii).gt.z(i2)) zz2(ii)=z(i2)
                     IF (zz2(ii).lt.zphot(i_sol)) zz2(ii)=z2
                  END DO
               END IF

c ..... Values before izmin

               z_b2(1)=zphot(i_sol)
               chi2_b2(1)=chi2sol(i_sol)
               i=izmin1
               ipass=0
               npoiz2=1
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5) THEN
                  q_pro2(1)=q_pro(izmin1)
                  ipass=1
               END IF
               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.and.
     .              izmin1.eq.i1) THEN
                  DO ii=1,3
                     zz1(ii)=z(i1)
                  END DO
                  npoiz2=1
               ELSE
 1004             CONTINUE
                  k=izmin1-i+2
                  q_pro2(k)=q_pro(i-ipass)
                  z_b2(k)=z(i-ipass)
                  chi2_b2(k)=z_min_array(i-ipass)
                  IF (i-ipass.gt.1.and.i-ipass.ge.izmin1) THEN
                     i=i-1
                     GO TO 1004
                  ELSE IF (i-ipass.gt.1.and.
     .                    (chi2_b2(k)-chi2sol(i_sol)).le.val(1)) THEN
                     i=i-1
                     GO TO 1004
                  END IF
                  npoiz2=k

                  DO ii=1,3     !z at P = 99 90 and 68%
                     l=0
                     zz1(ii)=rlin(val(ii)+chi2sol(i_sol),
     .                    chi2_b2,z_b2,npoiz2,l)
                     IF (zz1(ii).lt.z(i1)) zz1(ii)=z(i1)
                     IF (zz1(ii).gt.z(i2)) zz1(ii)=z(i2)
                     IF (zz1(ii).gt.zphot(i_sol)) zz1(ii)=zphot(i_sol)
                  END DO
               END IF

c ..... Ordering q_proz et z_b

               IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.
     .              and.izmin1.eq.i1) THEN
                  npoiz=npoiz1  ! points after only 
                  DO ii=1,npoiz
                     q_proz(ii)=q_pro1(ii)
                     z_b(ii)=z_b1(ii)
                  END DO         
               ELSE IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.and.
     .                 izmin1.eq.i2) THEN
                  npoiz=npoiz2  ! points before only  
                  DO ii=1,npoiz
                     q_proz(ii)=q_pro2(npoiz2-(ii-1))
                     z_b(ii)=z_b2(npoiz2-(ii-1))
                  END DO         
               ELSE IF (ABS(z(izmin1)-zphot(i_sol)).lt.1.e-5.and.
     .                 izmin1.ne.1.and.izmin1.ne.i2) THEN
                  npoiz=npoiz1+npoiz2-1
                  DO ii=1,npoiz2 ! points before
                     q_proz(ii)=q_pro2(npoiz2-(ii-1))
                     z_b(ii)=z_b2(npoiz2-(ii-1))
                  END DO
                  DO ii=1,npoiz1-1 ! points after (skip zphot(i_sol))
                     q_proz(npoiz2+ii)=q_pro1(ii+1)
                     z_b(npoiz2+ii)=z_b1(ii+1)
                  END DO
               ELSE
                  npoiz=npoiz1+npoiz2-2
                  DO ii=1,npoiz2-1 ! points before (skip zphot(i_sol))
                     q_proz(ii)=q_pro2(npoiz2-(ii-1))
                     z_b(ii)=z_b2(npoiz2-(ii-1))
                  END DO
                  DO ii=1,npoiz1-1 ! points after (skip zphot(i_sol))
                     q_proz(npoiz2+ii-1)=q_pro1(ii+1)
                     z_b(npoiz2+ii-1)=z_b1(ii+1)
                  END DO
               END IF

               DO ii=1,npoiz
                  poids=poids+q_proz(ii)
                  poids_z=poids_z+q_proz(ii)*z_b(ii)
               END DO

c ..... absolute magnitude
               itypem=i_typ(izmin)
               iredm=i_red(izmin)
               av=avmin+(iredm-1)*averr
               ilyfm=i_lyf(izmin)
               fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)
               sauce=flux(n_fil_w(izmin),izmin,itypem,iredm,ilyfm)
     .              /flux(n_fil_w(izmin),0,itypem,iredm,ilyfm)
               IF (sauce.gt.0.0D0) bmag=amag(n_fil_w(izmin))+
     .              2.5D0*DLOG10(sauce)-d_mod(h0,om,ov,zphot(i_sol)) 

               sauce=flux(0,0,itypem,iredm,ilyfm)*surf(0)
               IF (sauce.gt.0.0D0) amagb=bmag-
     .              (zeropoint(n_fil_w(izmin))-
     .              2.5D0*DLOG10(flux(n_fil_w(izmin),0,itypem,
     .              iredm,ilyfm)*surf(n_fil_w(izmin))/sauce)) 
               IF (magtyp.eq.1) amagb=amagb+conv_mag(0)

c ..... z weighted mean
               IF (poids.gt.0.0) THEN
                  z_poids=poids_z/poids
                  l=0
                  qq_p=rlin(z_poids,z_b,q_proz,npoiz,l)
               ELSE 
                  z_poids=zphot(i_sol)
                  qq_p=qq
               END IF

               IF (sed_abc(itypem).eq.'AS'.or.sed_abc(itypem).eq.'A ') 
     .              THEN
                  bbb=bb(i_sol)/rnorm_as(ntyp(itypem))
               ELSE 
                  bbb=bb(i_sol)
               END IF
               WRITE(10,2001) id,zphot(i_sol),r_chi2,qq,itypem,iage,
     .              age,av,bbb,zz1(1),zz2(1),zz1(2),zz2(2),
     .              zz1(3),zz2(3),z_poids,qq_p,amagb,fact_lyf,i_sol
            END IF
         END DO
      END IF

c -----------------------------------------------------------------------
c                    Graphics: Synthetic spectrum at zphot
c -----------------------------------------------------------------------

c ..... Write SED of object 'id'

      izmin=izphot(1)
      itypem=i_typ(izmin)
      iredm=i_red(izmin)
      av=avmin+(iredm-1)*averr
      ilyfm=i_lyf(izmin)
      fact_lyf=r_lyf**(ilyfm-1)*(1.D0/r_lyf)

c ..... File .obs_sed
      IF (csed1.eq.'y'.or.csed1.eq.'Y') THEN
         IF (iunit_sed.eq.0) THEN
            WRITE(15,fmt2) id,(fl1(i),i=1,n_filter),
     .           (err_fl(i),i=1,n_filter)
         ELSE IF (iunit_sed.eq.1) THEN
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               DO k=1,n_filter
                  f_jy(k)=fl1(k)*2.D-17*(wl(k)**2/(2.9979D+18))*1.D+29
c                  err_jy(k)=(2.3/2.5)*f_jy(k)*err_p(k)
                  err_jy(k)=0.4D0*DLOG(10.D0)*f_jy(k)*err_p(k)
               END DO
            END IF
            WRITE(15,fmt2) id,(f_jy(i),i=1,n_filter),
     .           (err_jy(i),i=1,n_filter)
         ELSE IF (iunit_sed.eq.2) THEN
            IF (magtyp.eq.0.or.magtyp.eq.1) THEN
               DO k=1,n_filter
                  IF (amag(k).gt.90.D0) THEN
                     amag(k)=mag_nd(k)+conv_mag(k)
                     err_p(k)=99.D0
                  ELSE IF (amag1(k).lt.1.D0) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  ELSE
                     amag(k)=amag1(k)+conv_mag(k)
                  END IF
               END DO
            ELSE IF (magtyp.eq.2) THEN
               DO k=1,n_filter
                  IF (amag(k).lt.-90.D0) THEN
                     err_p(k)=99.D0
                     amag(k)=mag_nd(k)+conv_mag(k)
                  ELSE IF (ABS(amag(iii)+1).lt.1.D-6) THEN
                     amag(k)=-1.D0
                     err_p(k)=-1.D0
                  ELSE
                     err_p(k)=2.5D0/DLOG(10.D0)*err_p(k)/amag(k)
                     amag(k)=amag1(k)+conv_mag(k)
                  END IF
               END DO
            END IF
            WRITE(15,fmt1) id,(amag(i),i=1,n_filter),
     .           (err_p(i),i=1,n_filter)
         END IF
      END IF

      IF (csed2.eq.'y'.or.csed2.eq.'Y'.or.iout_s.gt.1) THEN 
         DO k=1,iw(itypem)
            y(k)=f_as(k,ntyp(itypem))
            ww(k)=DBLE(w_as(k,ntyp(itypem)))
         END DO
         av=avmin+(iredm-1)*averr
         IF (av.gt.0.0) THEN
            CALL red_spec(ww,y,av,yob,1,iw(itypem),law_rd)
            DO k=1,iw(itypem)  
               y(k)=yob(k)
            END DO
         END IF
         CALL lyman_forest(ww,y,iw(itypem),zphot(1))
      END IF

      IF (csed2.eq.'y'.or.csed2.eq.'Y') THEN 
         DO k=1,n_filter
            fl_temp(k)=filter(nfil(k),ww,y,iw(itypem),zphot(1))/surf(k)
         END DO
         IF (iunit_sed.eq.0) THEN
            WRITE(19,fmt4) id,(bb(1)*fl_temp(k),k=1,n_filter)
         ELSE IF (iunit_sed.eq.1) THEN
            WRITE(19,fmt4) id,(bb(1)*2.D-17*fl_temp(k)*
     .     (wl(k)**2/(2.9979D+18))*1.D+29,k=1,n_filter)
         ELSE IF (iunit_sed.eq.2) THEN
            DO k=1,n_filter
               IF (fl_temp(k).gt.0.D0) THEN
                  mag_temp(k)=-2.5D0*DLOG10(bb(1)*fl_temp(k)*
     .                 surf(k)/vega(k))+conv_mag(k)
               ELSE
                  mag_temp(k)=99.D0
               END IF
            END DO
            WRITE(19,fmt3) id,(mag_temp(k),k=1,n_filter)
         END IF
      END IF

      IF (iout_s.gt.1) THEN
         spectra=root(1:iroot)//'.spe'

         IF (iunit_sed.eq.0) THEN
            DO k=1,iw(itypem)
               y(k)=bb(1)*y(k)/(1.D0+zphot(1))
            END DO
         ELSE IF (iunit_sed.eq.1) THEN
            DO k=1,iw(itypem)
               y(k)=bb(1)*y(k)*2.D-17*(ww(k)**2/2.9979D+18)*1.D+29*
     .              (1.D0+zphot(1))
            END DO
         ELSE IF (iunit_sed.eq.2) THEN
            DO k=1,iw(itypem)
               y(k)=bb(1)*y(k)*2.D-17*(ww(k)**2/2.9979D+18)*
     .              (1.D0+zphot(1))
               IF (y(k).ne.0.D0) THEN
                  y(k)=-2.5D0*DLOG10(y(k))-48.60D0
               ELSE
                  y(k)=100.D0
               END IF
            END DO
         END IF
         iwav=0
         wmin1=1.D5
         wmax1=0.D0
         DO k=1,n_filter
            wmin0=wl(k)-0.5D0*surf(k)-1000.D0
            wmax0=wl(k)+0.5D0*surf(k)+1000.D0
            IF (wmin0.lt.wmin1) wmin1=wmin0
            IF (wmax0.gt.wmax1) wmax1=wmax0
         END DO
         DO k=1,iw(itypem)
            w0=ww(k)*(1.D0+zphot(1))
            IF ((w0.ge.wmin1.and.w0.le.wmax1).or.
     .           (w0.le.wmin1.and.w0.ge.wmax1)) THEN
               iwav=iwav+1
               wsyn(iwav)=ww(k)*(1.D0+zphot(1))
               ysyn(iwav)=y(k)
            END IF
         END DO
         OPEN(12,FILE=spectra,STATUS='unknown')
         DO k=1,iwav
            WRITE(12,2013) wsyn(k),ysyn(k)
         END DO
         CLOSE(12)
      END IF

c.......................................................................
      GO TO 13400
13500 CONTINUE
c.......................................................................

      CLOSE(16)
      IF (ccat.eq.'y'.or.ccat.eq.'Y') CLOSE(10)
      IF (clog.eq.'y'.or.clog.eq.'Y') CLOSE(14)
      IF (csed1.eq.'y'.or.csed1.eq.'Y') CLOSE(15)
      IF (cz.eq.'y'.or.cz.eq.'Y') CLOSE(17)
      IF (csed2.eq.'y'.or.csed2.eq.'Y') CLOSE(19)

      time_tot=DBLE(cputime())-time_tot
      WRITE(*,'(a)') ' Done !!!'
      WRITE(*,'(1X,A,F12.3,A)') 'Total CPU time involved : ', time_tot, 
     .     ' seconds'
      WRITE(18,'(1X,A,F12.3,A)') '#  Total CPU time involved : ',  
     .     time_tot,' seconds'
      CLOSE(18)
      STOP
 2001 FORMAT(i10,1x,f6.3,1x,f8.3,1x,f6.2,1x,i3,1x,i3,1x,f8.4,1x,f5.2,
     .     1x,e9.3,1x,6(f6.3,1x),f6.3,1x,f6.2,1x,f7.2,1x,F6.3,1x,i3)
 2002 FORMAT(i10,1x,f6.3,1x,e11.4,1x,f10.5,1x,i3,1x,f8.4,1x,F4.2,1x,
     .     F6.3)
 2008 FORMAT(i10,1x,f8.5,1x,f8.3,1x,f6.2,1x,i3,1x,i3,1x,f8.4,1x,
     .     f5.2,1x,e9.3,1x,6(f6.3,1x),f6.3,1x,f6.2,1x,f7.2,1x,F6.3,1x,
     .     f6.3,1x,f6.2)
 2009 FORMAT(i10,1x,f8.5,1x,f8.3,1x,f6.2,1x,i3,1x,i3,1x,f8.4,1x,
     .     f5.2,1x,e9.3,1x,6(f6.3,1x),f6.3,1x,f6.2,1x,f7.2,1x,f6.3,1x,
     .     f6.3,1x,f7.2,1x,F6.3,1x,f6.2,1x,f6.2)
 2012 FORMAT(i10,1x,f6.3,1x,i2,1x,i3,1x,f8.4,1x,f5.2,1x,F6.3,1x,E11.5)
 2013 FORMAT(1x,f15.4,4x,e20.13)
 25   STOP 'Error opening synthetic spectra files'
 78   STOP 'Error opening templates file'
 79   STOP 'Error opening or reading photometric catalog'
 80   STOP 'Error opening filters file'
 81   STOP 'Error opening output files'
 82   STOP 'Error reading filters file'
      END
c----------------------------------------------------------------------
      FUNCTION func(x)
      IMPLICIT NONE
      REAL*8 func,pchi2,x,deg,prob
      EXTERNAL pchi2
      COMMON/nfree/deg,prob
c
      func=prob-pchi2(0.5D0*deg,0.5D0*x)
      RETURN
      END

c----------------------------------------------------------------------
c ..... Distance module: d_mod = 5*LOG10(d_L[pc]/10)
 
      FUNCTION d_mod(h0,om,ov,za)
      IMPLICIT NONE
      INTEGER nstep,i
      REAL*8 d_mod,h0,om,ov,z,za,c,dmin,d_l,ee,s,s1,s2,dz,a,b,x
      PARAMETER (c=2.9979D+5,nstep=100)
      ee(x)=DSQRT(om*(1.D0+x)**3+(1.D0-om-ov)*(1.D0+x)**2+ov)
c
      IF (za.lt.1.D-5) THEN
         z=1.D-5
      ELSE
         z=za
      END IF
      IF (om.lt.0.001D0.and.ov.lt.1.D-8) THEN
         d_l=(1.D0+z)*DLOG(1.D0+z)
      ELSE IF ((om-1.D0).lt.1.D-8.and.ov.lt.1.D-8) THEN
         d_l=2.D0*(1.D0+z)*(1.D0-1.D0/DSQRT(1.D0+z))
      ELSE IF (om.lt.1.D0.and.om.gt.0.01D0.and.ov.lt.1.D-8) THEN
         d_l=(2.D0/om**2)*(om*z-(2.D0-om)*(-1.D0+DSQRT(om*z+1.D0))) ! Mattig
      ELSE
         dz=z/DBLE(FLOAT(nstep))
         s=0.D0
         d_l=0.D0
         DO i=1,nstep+1
            a=(i-1)*dz
            b=i*dz
            s1=(1.D0/ee(a))
            s2=(1.D0/ee(b))
            s=dz*(s1+s2)*0.5D0
            d_l=d_l+s
         END DO
         d_l=(1.D0+z)*d_l
      END IF
      d_mod=5.D0*DLOG10((c/h0)*d_l)+25.D0
c   minimum d_mod: corresponding to d(~M31)=1000 Kpc
      dmin=25.D0
      IF (d_mod.lt.dmin) d_mod=dmin
      RETURN
      END
c ----------------------------------------------------------------------

      SUBROUTINE zfit_min(itypem,av,zmin_f,zmax_f,dz_f,chi2,zop)
      IMPLICIT NONE
      INTEGER law_rd,n_filter,nfil,iw,i_lyman,k,i,itypem,ntyp,
     .     nz_f,i_min,mxwl_as,mxfil,mxtyp_as,mxz,mxred,mxlyf
      REAL*8 dif,yob,y,y1,fluz,fl2,ww,f_as,fl,
     .     err_fl,fact_lyf,av,zmin_f,zmax_f,dz_f,chi2,zop,surf,zz,filter
      REAL*8 bm,wt,sxx,sxy,b
      REAL w_as
      INCLUDE 'dimension_star.dec'
      DIMENSION dif(101),yob(mxwl_as),y(mxwl_as),y1(mxwl_as),
     .     fluz(mxfil),fl2(mxfil),ww(mxwl_as)
      EXTERNAL filter
      COMMON/et1/surf(0:mxfil)
      COMMON/et2/fl(mxfil),err_fl(mxfil)
      COMMON/et2b/w_as(mxwl_as,mxtyp_as),f_as(mxwl_as,mxtyp_as)
      COMMON/et3/law_rd
      COMMON/et4/n_filter,nfil(0:mxfil),iw(mxtyp_as),i_lyman(mxfil)
      COMMON/et5/bm
      COMMON/et6/ntyp(mxtyp_as)
      COMMON/lyf_sigma/fact_lyf
      
      nz_f=NINT((zmax_f-zmin_f)/dz_f)+1
      chi2=1.D+12
      DO k=1,iw(itypem) 
         y(k)=f_as(k,ntyp(itypem)) ! type minimum
         ww(k)=DBLE(w_as(k,ntyp(itypem)))
      END DO
      IF (av.gt.0.D0.and.law_rd.ne.0) THEN
         CALL red_spec(ww,y,av,yob,1,iw(itypem),law_rd)
         DO k=1,iw(itypem)
            y(k)=yob(k)
         END DO
      END IF

      DO i=2,nz_f-1             !Scan in z excluding limits of range
         zz=zmin_f+(i-1)*dz_f
         DO k=1,iw(itypem)
            y1(k)=y(k)
         END DO
         CALL lyman_forest(ww,y1,iw(itypem),zz)
         dif(i)=0.0D0
         sxx=0.D0
         sxy=0.D0
         b=0.D0
         DO k=1,n_filter
            fluz(k)=filter(nfil(k),ww,y1,iw(itypem),zz)/surf(k)
         END DO

         DO k=1,n_filter
            IF (fl(k).ge.0.) THEN ! no oof objects
               IF (fluz(k).lt.1.D-12.and.i_lyman(k).eq.1) THEN
                  fl2(k)=0.D0
               ELSE
                  fl2(k)=fl(k)
                  wt=1.D0/(err_fl(k)**2)
                  sxx=sxx+(fluz(k)**2)*wt
                  sxy=sxy+fluz(k)*fl2(k)*wt
               END IF
            ELSE
               fl2(k)=-1.D0
            END IF
         END DO
         b=sxy/sxx
         DO k=1,n_filter
            IF (fl2(k).ge.0.D0) THEN ! no oof objects
               dif(i)=dif(i)+((fl2(k)-b*fluz(k))/err_fl(k))**2
            END IF
         END DO

         IF (dif(i).lt.chi2) THEN
            chi2=dif(i)
            i_min=i
            bm=b
         END IF
      END DO

      zop=zmin_f+(i_min-1)*dz_f

      RETURN
      END

c ----------------------------------------------------------------------

      SUBROUTINE lyman_forest(wl,fl,iw,z)

c ..... Computes the Lyman forest mean absorption of an 
c       input spectrum, according to <D_A> and <D_B> evolution 
c       from Madau (1995).

      IMPLICIT NONE
      INTEGER i,nw,iw,mxz,mxtyp_as,mxfil,mxred,mxlyf,mxwl_as
      PARAMETER (nw=100)
      REAL*8 fl,wl,ptau,da,db,z,zl,wtemp,w1,w2,wstep,fact_lyf,tau_eff,
     .     trapz1
      INCLUDE 'dimension_star.dec'
      DIMENSION wl(mxwl_as),fl(mxwl_as),ptau(nw),wtemp(nw)
      EXTERNAL trapz1
      COMMON/lyf_sigma/fact_lyf

      IF (z.lt.0.D0) THEN
         zl=0.D0
      ELSE
         zl=z
      END IF
      w1=1050.D0*(1.D0+zl)
      w2=1170.D0*(1.D0+zl)
      wstep=(w2-w1)/DBLE(FLOAT(nw))
      
      DO i=1,nw
         wtemp(i)=w1+(i-1)*wstep
         tau_eff=3.6D-3*(wtemp(i)/1216.D0)**3.46D0
         ptau(i)=DEXP(-tau_eff*fact_lyf)
      END DO

      da=(1.D0/(120.D0*(1.D0+zl)))*trapz1(wtemp,ptau,nw) ! da = 1-<D_A>

      w1=920.D0*(1.D0+zl)
      w2=1015.D0*(1.D0+zl)
      wstep=(w2-w1)/DBLE(FLOAT(nw))

      DO i=1,nw
         wtemp(i)=w1+(i-1)*wstep
         tau_eff=1.7D-3*(wtemp(i)/1026.D0)**3.46D0
     .        +1.2D-3*(wtemp(i)/972.5D0)**3.46D0
     .        +9.3D-4*(wtemp(i)/950.D0)**3.46D0
         ptau(i)=DEXP(-tau_eff*fact_lyf)
      END DO

      db=(1.D0/(95.D0*(1.D0+zl)))*trapz1(wtemp,ptau,nw) ! db = 1-<D_B>

c More Lyman blanketing
c      da=0.5*da
c      db=0.5*db
c Less Lyman blanketing
c      da=2.0*da
c      db=2.0*db

      IF (da.gt.1.D0) da=1.D0
      IF (db.gt.1.D0) db=1.D0
      IF (da.lt.0.D0) da=0.D0
      IF (db.lt.0.D0) db=0.D0

c        correcting spectrum:

      DO i=1,iw
         IF (wl(i).lt.1216.0D0.and.wl(i).gt.1026.0D0) THEN !between Lya and Lyb
            fl(i)=fl(i)*da
         END IF
         IF (wl(i).le.1026.0D0) THEN               !between Lyb and 912A break
            fl(i)=fl(i)*db
         END IF
      END DO

      RETURN
      END
c ----------------------------------------------------------------------

      SUBROUTINE red_spec(wl,fl,av,yob,kred,iwavl,law_rd)
c     Reads a spectrum and calculates the new one with internal
c     reddening. 
c     law_rd=1 : the standard variation of absorption with wavelength 
c                is used (Allen, 1976) - MW
c     law_rd=2 : the analytic fit of Seaton (1979) curve by 
c                Fitzpatrick (1986) - MW 
c     law_rd=3 : Fitzpatrick (1986) - LMC
c     law_rd=4 : Prevot et al. (1984) and Bouchet et al. (1985) - SMC
c     law_rd=5 : Calzetti (2000) - SB
c    
      IMPLICIT NONE
      INTEGER kred,iwavl,law_rd,mxz,mxtyp_as,mxfil,mxred,mxlyf,mxwl_as,
     .     ik,i
      REAL*8 yob,alambda,wl,fl,wab,amab,aab,av,ff,ff11,ff12,slope,rv,
     .     ccc,al0,ga,c1,c2,c3,c4,p11,p12,ff99,ff100,slope2,slope1,
     .     p,ala
      INCLUDE 'dimension_star.dec'
      DIMENSION yob(mxwl_as),wl(mxwl_as),fl(mxwl_as)
      DIMENSION wab(30),amab(30),aab(30)
c ..... 1. Allen (1976) : wab = lambda in A, amab = k(lambda)/R, 
c          A(lambda) = k(lambda)*E(B-V) = amab*A_V ; R = 3.1

      IF (law_rd.eq.1) THEN
         rv=3.1D0
         wab(1)=1000.D0
         amab(1)=4.2D0
         wab(2)=1110.D0
         amab(2)=3.7D0
         wab(3)=1250.D0
         amab(3)=3.3D0
         wab(4)=1430.D0
         amab(4)=3.D0
         wab(5)=1670.D0
         amab(5)=2.7D0
         wab(6)=2000.D0
         amab(6)=2.8D0
         wab(7)=2220.D0
         amab(7)=2.9D0
         wab(8)=2500.D0
         amab(8)=2.30D0
         wab(9)=2850.D0
         amab(9)=1.97D0
         wab(10)=3330.D0
         amab(10)=1.69D0
         wab(11)=3650.D0
         amab(11)=1.58D0
         wab(12)=4000.D0
         amab(12)=1.45D0
         wab(13)=4400.D0
         amab(13)=1.32D0
         wab(14)=5000.D0
         amab(14)=1.13D0
         wab(15)=5530.D0
         amab(15)=1.00D0
         wab(16)=6700.D0
         amab(16)=0.74D0
         wab(17)=9000.D0
         amab(17)=0.46D0
         wab(18)=10000.D0
         amab(18)=0.38D0
         wab(19)=20000.D0
         amab(19)=0.11D0
         wab(20)=100000.D0
         amab(20)=0.0D0
         DO i=1,20
            aab(i)=amab(i)*av
         END DO
         DO ik=1,iwavl
            IF (wl(ik).le.wab(1)) THEN 
               ccc=(aab(1)-aab(2))/(wab(2)-wab(1))
               alambda=aab(1)+(wab(1)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.wab(20)) THEN
               alambda=0.D0
            ELSE IF (wl(ik).ge.wab(19).and.wl(ik).le.wab(20)) THEN 
               ccc=(aab(19)-aab(20))/(wab(20)-wab(19))
               alambda=aab(19)+(wab(19)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.wab(1).and.wl(ik).lt.wab(19)) THEN
               DO i=1,19
                  IF (wl(ik).ge.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                     ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                     alambda=aab(i)+(wab(i)-wl(ik))*ccc
                  END IF
               END DO
            END IF
            IF (alambda.lt.0.D0) alambda=0.D0
            IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
            IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
         END DO
         RETURN

c ..... 2. Seaton (1979) - Fitzpatrick fit : 
c                       for lambda < 1200 A slope from 1100-1200
c                       for lambda > 3650 A points from Allen
c                       ff = E(lambda-V)/E(B-V) = k(lambda)-R
c                       A(lambda)=A_V*(ff/R +1) ; R = 3.1

      ELSE IF (law_rd.eq.2) THEN
         rv=3.1D0
         al0=4.595D0
         ga=1.051D0
         c1=-0.38D0
         c2=0.74D0
         c3=3.96D0
         c4=0.26D0
         call red(1100.D0,al0,ga,c1,c2,c3,c4,ff)
         ff11=ff
         call red(1200.D0,al0,ga,c1,c2,c3,c4,ff)
         ff12=ff
         slope=(ff12-ff11)/100.D0
         wab(11)=3650.D0
         amab(11)=1.58D0
         wab(12)=4000.D0
         amab(12)=1.45D0
         wab(13)=4400.D0
         amab(13)=1.32D0
         wab(14)=5000.D0
         amab(14)=1.13D0
         wab(15)=5530.D0
         amab(15)=1.00D0
         wab(16)=6700.D0
         amab(16)=0.74D0
         wab(17)=9000.D0
         amab(17)=0.46D0
         wab(18)=10000.D0
         amab(18)=0.38D0
         wab(19)=20000.D0
         amab(19)=0.11D0
         wab(20)=100000.D0
         amab(20)=0.0D0
         DO i=11,20
            aab(i)=amab(i)*av
         END DO
         DO ik=1,iwavl
            IF (wl(ik).ge.1200.D0.and.wl(ik).le.3650.D0) THEN
               call red(wl(ik),al0,ga,c1,c2,c3,c4,ff)
               alambda=av*(ff/rv+1.D0) 
            ELSE IF (wl(ik).lt.1200.D0) THEN
               ff=ff11+(wl(ik)-1100.D0)*slope
               alambda=av*(ff/rv+1.D0)
            ELSE IF (wl(ik).gt.wab(20)) THEN
               alambda=0.D0
            ELSE IF (wl(ik).ge.wab(19).and.wl(ik).le.wab(20)) THEN 
               ccc=(aab(19)-aab(20))/(wab(20)-wab(19))
               alambda=aab(19)+(wab(19)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.3650.D0.and.wl(ik).lt.wab(19)) THEN
               DO i=11,19
                  IF (wl(ik).gt.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                     ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                     alambda=aab(i)+(wab(i)-wl(ik))*ccc
                  END IF
               END DO
            END IF
            IF (alambda.lt.0.D0) alambda=0.D0
            IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
            IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
         END DO
         RETURN
      
c ..... 3. Fitzpatrick (1986) : 
c                       for lambda < 1200 A slope derived from 1100-1200
c                       for lambda > 3330 A points from Allen
c                       ff = E(lambda-V)/E(B-V) = k(lambda)-R
c                       A(lambda) = A_V*(ff/R +1) ; R = 3.1

      ELSE IF (law_rd.eq.3) THEN
         rv=3.1D0
         al0=4.608D0
         ga=0.994D0
         c1=-0.69D0
         c2=0.89D0
         c3=2.55D0
         c4=0.50D0
         call red(1100.D0,al0,ga,c1,c2,c3,c4,ff)
         ff11=ff
         call red(1200.D0,al0,ga,c1,c2,c3,c4,ff)
         ff12=ff
         slope=(ff12-ff11)/100.D0
         wab(10)=3330.D0
         amab(10)=1.682D0
         wab(11)=3650.D0
         amab(11)=1.58D0
         wab(12)=4000.D0
         amab(12)=1.45D0
         wab(13)=4400.D0
         amab(13)=1.32D0
         wab(14)=5000.D0
         amab(14)=1.13D0
         wab(15)=5530.D0
         amab(15)=1.00D0
         wab(16)=6700.D0
         amab(16)=0.74D0
         wab(17)=9000.D0
         amab(17)=0.46D0
         wab(18)=10000.D0
         amab(18)=0.38D0
         wab(19)=20000.D0
         amab(19)=0.11D0
         wab(20)=100000.D0
         amab(20)=0.0D0
         DO i=10,20
            aab(i)=amab(i)*av
         END DO
         DO ik=1,iwavl
            IF (wl(ik).ge.1200.D0.and.wl(ik).le.3330.D0) THEN
               call red(wl(ik),al0,ga,c1,c2,c3,c4,ff)
               alambda=av*(ff/rv+1.D0)
            ELSE IF (wl(ik).lt.1200.D0) THEN
               ff=ff11+(wl(ik)-1100.D0)*slope
               alambda=av*(ff/rv+1.D0)
            ELSE IF (wl(ik).gt.wab(20)) THEN
               alambda=0.D0
            ELSE IF (wl(ik).ge.wab(19).and.wl(ik).le.wab(20)) THEN 
               ccc=(aab(19)-aab(20))/(wab(20)-wab(19))
               alambda=aab(19)+(wab(19)-wl(ik))*ccc
            ELSE IF (wl(ik).gt.3330.D0.and.wl(ik).lt.wab(19)) THEN
               DO i=10,19
                  IF (wl(ik).gt.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                     ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                     alambda=aab(i)+(wab(i)-wl(ik))*ccc
                  END IF
               END DO
            END IF
            IF (alambda.lt.0.D0) alambda=0.D0
            IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
            IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
         END DO
         RETURN

c ..... 4. Prevot (1984) and Bouchet (1985) :
c                        wab = lambda in A,  
c                        amab = E(lambda-V)/E(B-V) = k(lambda)-R
c                        A(lambda) = A_V*(amab/R +1)
c                        N.B. R = 2.72

         ELSE IF (law_rd.eq.4) THEN
            rv=2.72D0
            wab(1)=1275.D0
            amab(1)=13.54D0
            wab(2)=1330.D0
            amab(2)=12.52D0
            wab(3)=1385.D0
            amab(3)=11.51D0
            wab(4)=1435.D0
            amab(4)=10.80D0
            wab(5)=1490.D0
            amab(5)=9.84D0
            wab(6)=1545.D0
            amab(6)=9.28D0
            wab(7)=1595.D0
            amab(7)=9.06D0
            wab(8)=1647.D0
            amab(8)=8.49D0
            wab(9)=1700.D0
            amab(9)=8.01D0
            wab(10)=1755.D0
            amab(10)=7.71D0
            wab(11)=1810.D0
            amab(11)=7.17D0
            wab(12)=1860.D0
            amab(12)=6.90D0
            wab(13)=1910.D0
            amab(13)=6.76D0
            wab(14)=2000.D0
            amab(14)=6.38D0
            wab(15)=2115.D0
            amab(15)=5.85D0
            wab(16)=2220.D0
            amab(16)=5.30D0
            wab(17)=2335.D0
            amab(17)=4.53D0
            wab(18)=2445.D0
            amab(18)=4.24D0
            wab(19)=2550.D0
            amab(19)=3.91D0
            wab(20)=2665.D0
            amab(20)=3.49D0
            wab(21)=2778.D0
            amab(21)=3.15D0
            wab(22)=2890.D0
            amab(22)=3.00D0
            wab(23)=2995.D0
            amab(23)=2.65D0
            wab(24)=3105.D0
            amab(24)=2.29D0
            wab(25)=3704.D0
            amab(25)=1.81D0
            wab(26)=4255.D0
            amab(26)=1.00D0
            wab(27)=5291.D0
            amab(27)=0.00D0
            wab(28)=12500.D0
            amab(28)=-2.02D0
            wab(29)=16500.D0
            amab(29)=-2.36D0
            wab(30)=22000.D0
            amab(30)=-2.47D0

            DO i=1,30
               aab(i)=av*(amab(i)/rv+1.D0)
            END DO

            DO ik=1,iwavl
               IF (wl(ik).le.wab(1)) THEN !extrapol at short wavelengths
                  ccc=(aab(1)-aab(2))/(wab(2)-wab(1))
                  alambda=aab(1)+(wab(1)-wl(ik))*ccc
               ELSE IF(wl(ik).ge.wab(30)) THEN !extrapol at high wavelengths
                  ccc=(aab(29)-aab(30))/(wab(30)-wab(29))
                  alambda=aab(29)+(wab(29)-wl(ik))*ccc  
               ELSE IF (wl(ik).gt.wab(1).and.wl(ik).lt.wab(30)) THEN
                  DO i=1,30
                     IF (wl(ik).gt.wab(i).and.wl(ik).lt.wab(i+1)) THEN
                        ccc=(aab(i)-aab(i+1))/(wab(i+1)-wab(i))
                        alambda=aab(i)+(wab(i)-wl(ik))*ccc
                     END IF
                  END DO
               END IF   
               IF (alambda.lt.0.D0) alambda=0.D0
               IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
               IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
            END DO
            RETURN


c ..... Calzetti (1999) : 
c                   for lambda < 1200 A slope derived from 1100-1200 A
c                   for lambda > 22000A slope derived from 21900-22000 A
c                   ff = k(lambda); A(lambda) = A_V*k(lambda)/R ; R = 4.05

      ELSE IF (law_rd.eq.5) THEN
         rv=4.05D0
         p11=1.D0/0.11D0
         ff11=2.659D0*(-2.156D0+1.509D0*p11-0.198D0*p11**2
     .        +0.011D0*p11**3)+rv
         p12=1.D0/0.12D0
         ff12=2.659D0*(-2.156D0+1.509D0*p12-0.198D0*p12**2
     .        +0.011D0*p12**3)+rv
         slope1=(ff12-ff11)/100.D0
         ff99=2.659D0*(-1.857D0+1.040D0/2.19D0)+rv
         ff100=2.659D0*(-1.857D0+1.040D0/2.2D0)+rv
         slope2=(ff100-ff99)/100.D0
         DO ik=1,iwavl
            IF (wl(ik).lt.1.D-12) THEN
               IF (kred.eq.1) yob(ik)=0.D0 
               IF (kred.eq.2) yob(ik)=fl(ik) 
            ELSE
               ala=wl(ik)*1.D-4 !wavelength in microns
               p=1.D0/ala
               IF (ala.ge.0.63D0.and.ala.le.2.2D0) THEN
                  ff=2.659D0*(-1.857D0+1.040D0*p)+rv
               ELSE IF (ala.ge.0.12D0.and.ala.lt.0.63D0) THEN
                  ff=2.659D0*(-2.156D0+1.509D0*p-0.198D0*p**2+
     .                 0.011D0*p**3)+rv
               ELSE IF (ala.lt.0.12D0) THEN
                  ff=ff11+(wl(ik)-1100.D0)*slope1
               ELSE IF (ala.gt.2.2D0) THEN
                  ff=ff99+(wl(ik)-21900.D0)*slope2
               END IF
               alambda=av*ff/rv
               IF (alambda.lt.0.D0) alambda=0.D0
               IF (kred.eq.1) yob(ik)=fl(ik)*(10**(-0.4D0*alambda))
               IF (kred.eq.2) yob(ik)=fl(ik)*(10**(0.4D0*alambda))
            END IF
         END DO
         RETURN
      END IF

      WRITE(*,*) ' No reddening law is given.....'
      RETURN
      END

c ----------------------------------------------------------------------
      SUBROUTINE red(alan,al0,ga,c1,c2,c3,c4,ff)
      IMPLICIT NONE
      REAL*8 ala,alan,al0,ga,c1,c2,c3,c4,ff,p,t1,t2

c.......According to Fitzpatrick, 86

      ala=alan*1.D-4           !wavelength in microns
      p=1.0D0/ala
      IF (p.lt.5.9D0) c4=0.0D0
      t1=c3/(((p-(al0**2/p))**2)+ga*ga)
      t2=c4*(0.539D0*((p-5.9D0)**2)+0.0564D0*((p-5.9D0)**3))
      ff=c1+c2*p+t1+t2
      RETURN
      END

c ----------------------------------------------------------------------

